﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace ViewModels.Exam
{
    /// <summary>
    /// Summary description for Angle Recession Event
    /// </summary>
    [Serializable]
    public class AngleRecessionEventModel : BaseEventModel
    {
        public override string CategoryCode
        {
            get { return "AngRecesss"; }
        }

        public MultiSelectQuestion VisitData { get; set; }

        public Dictionary<string, TextQuestion>  ClockHours { get; set; }

        public List<VisitDataView> VisitDataViews
        {
            get
            {
                return VisitData.SelectedChoicesOrderd.Select(
                    c =>
                        new VisitDataView()
                        {
                            Code = c.Code,
                            DisplayText = c.DisplayText,
                            RequiresComment = c.RequiresComment,
                            Comment = c.Comment,
                            ClockHour = ClockHours.ContainsKey(c.Code) ? ClockHours[c.Code].ResponseText : string.Empty
                        })
                    .ToList();
            }
        }

        public class VisitDataView
        {
            public string Code { get; set; }
            public string DisplayText { get; set; }
            public bool RequiresComment { get; set; }
            public string Comment { get; set; }
            public string ClockHour { get; set; }
        }

        public static IEnumerable<string> ShowTestDetailValues
        {
            get
            {
                return new[]
                {
                    ChoiceCodes.TestPerformed.Yes
                };
            }
        }

        public static class QuestionCodes
        {
            public static string TestPerformed = "AR_TP";

            public static string TestResult= "AR_TR";

            public static string EventComment = "AR_C";
            
            public static string VisitData = "AR_VD";

            public static string ClockHourSuffix = "_CH";
        }

        public static class ChoiceCodes
        {
            public static class TestPerformed
            {
                public static string Yes = "AR_TP_Y";

                public static string NotDocumented = "AR_TP_ND";
            }

            public static class TestResult
            {
                public static string Normal = "AR_TR_N";

                public static string Abnormal = "AR_TR_A";
            }
        }
    }
}