﻿using System;
using System.Collections.Generic;

namespace ViewModels.Exam
{
    /// <summary>
    /// Summary description for Angle Recession Event
    /// </summary>
    [Serializable]
    public class AnteriorChamberEventModel : BaseEventModel
    {
        public override string CategoryCode
        {
            get { return "AntChamber"; }
        }

        public MultiSelectQuestion VisitData { get; set; }

        public static IEnumerable<string> ShowTestDetailValues
        {
            get
            {
                return new[]
                {
                    ChoiceCodes.TestPerformed.Yes
                };
            }
        }

        public static class QuestionCodes
        {
            public static string TestPerformed = "AC_TP";

            public static string TestResult = "AC_TR";

            public static string EventComment = "AC_C";

            public static string VisitData = "AC_VD";
        }

        public static class ChoiceCodes
        {
            public static class TestPerformed
            {
                public static string Yes = "AC_TP_Y";

                public static string NotDocumented = "AC_TP_ND";
            }

            public static class TestResult
            {
                public static string Normal = "AC_TR_N";

                public static string Abnormal = "AC_TR_A";
            }

            public static class VisitData
            {
                public static string HyphemaHeight = "AC_VD30";

                public static string HyphemaPercentage = "AC_VD33";
            }
        }
    }
}