﻿using System;
using System.Collections.Generic;

namespace ViewModels.Exam
{
    /// <summary>
    /// Summary description for Depth Perception Event Model
    /// </summary>
    [Serializable]
    public class DepthPerceptionEventModel : BaseEventModel
    {
        public override string CategoryCode
        {
            get { return "DepthPerc"; }
        }

        public SingleSelectQuestion RandotStereoTest { get; set; }

        public TextQuestion RandotFly { get; set; }

        public SingleSelectQuestion TitmusStereoTest { get; set; }

        public SingleSelectQuestion VectographicProjectorSlides { get; set; }

        public SingleSelectQuestion VisionTesterDepth { get; set; }

        public SingleSelectQuestion BorishVectographicNearpoint { get; set; }

        public TextQuestion VerhoeffSteropter { get; set; }

        public static IEnumerable<string> ShowTestDetailValues
        {
            get
            {
                return new[]
                {
                    ChoiceCodes.TestPerformed.Yes
                };
            }
        }

        public static class QuestionCodes
        {
            public static string TestPerformed = "DP_TP";

            public static string TestResult = "DP_TR";

            public static string EventComment = "DP_C";

            public static string RandotFly = "DP_RF";

            public static string VerhoeffSteropter = "DP_VS";

            public static string RandotStereoTest = "DP_RST";

            public static string TitmusStereoTest = "DP_TST";

            public static string VectographicProjectorSlides = "DP_VPS";

            public static string VisionTesterDepth = "DP_VTD";

            public static string BorishVectographicNearpoint = "DP_BVN";
        }

        public static class ChoiceCodes
        {
            public static class TestPerformed
            {
                public static string Yes = "DP_TP_Y";

                public static string NotDocumented = "DP_TP_ND";
            }

            public static class TestResult
            {
                public static string Normal = "DP_TR_N";

                public static string Abnormal = "DP_TR_A";
            }
        }
    }
}