﻿using System;
using System.Collections.Generic;

namespace ViewModels.Exam
{
    /// <summary>
    /// Summary description for Iris Event Model
    /// </summary>
    [Serializable]
    public class IrisEventModel : BaseEventModel
    {
        public override string CategoryCode
        {
            get { return "Iris"; }
        }

        public MultiSelectQuestion VisitData { get; set; }

        public static IEnumerable<string> ShowTestDetailValues
        {
            get
            {
                return new[]
                {
                    ChoiceCodes.TestPerformed.Yes
                };
            }
        }

        public static class QuestionCodes
        {
            public static string TestPerformed = "IR_TP";

            public static string TestResult = "IR_TR";

            public static string EventComment = "IR_C";

            public static string VisitData = "IR_VD";
        }

        public static class ChoiceCodes
        {
            public static class TestPerformed
            {
                public static string Yes = "IR_TP_Y";

                public static string NotDocumented = "IR_TP_ND";
            }

            public static class TestResult
            {
                public static string Normal = "IR_TR_N";

                public static string Abnormal = "IR_TR_A";
            }
        }
    }
}