﻿using System;
using System.Collections.Generic;

namespace ViewModels.Exam
{
    /// <summary>
    /// Summary description for Lids Event Model
    /// </summary>
    [Serializable]
    public class LidsEventModel : BaseEventModel
    {
        public override string CategoryCode
        {
            get { return "Lids"; }
        }

        public MultiSelectQuestion VisitData { get; set; }

        public static IEnumerable<string> ShowTestDetailValues
        {
            get
            {
                return new[]
                {
                    ChoiceCodes.TestPerformed.Yes
                };
            }
        }

        public static class QuestionCodes
        {
            public static string TestPerformed = "LD_TP";

            public static string TestResult = "LD_TR";

            public static string EventComment = "LD_C";

            public static string VisitData = "LD_VD";
        }

        public static class ChoiceCodes
        {
            public static class TestPerformed
            {
                public static string Yes = "LD_TP_Y";

                public static string NotDocumented = "LD_TP_ND";
            }

            public static class TestResult
            {
                public static string Normal = "LD_TR_N";

                public static string Abnormal = "LD_TR_A";
            }
        }
    }
}