﻿using System;
using System.Collections.Generic;

namespace ViewModels.Exam
{
    /// <summary>
    /// Summary description for Static Threshold Perimetry Event Model
    /// </summary>
    [Serializable]
    public class StaticThresholdPerimetryEventModel : BaseEventModel
    {
        public override string CategoryCode
        {
            get { return "StaticThresPer"; }
        }

        public SingleSelectQuestion ReferenceScale { get; set; }

        public TextQuestion MeanDeviation { get; set; }

        public TextQuestion PatternStandardDeviation { get; set; }

        public TextQuestion FixationLoses { get; set; }

        public static IEnumerable<string> ShowTestDetailValues
        {
            get
            {
                return new[]
                {
                    ChoiceCodes.TestPerformed.Yes
                };
            }
        }

        public static class QuestionCodes
        {
            public static string TestPerformed = "STP_TP";

            public static string TestResult = "STP_TR";

            public static string EventComment = "STP_C";

            public static string ReferenceScale = "STP_RS";

            public static string MeanDeviation = "STP_MD";

            public static string PatternStandardDeviation = "STP_PSD";

            public static string FixationLoses = "STP_FL";
        }

        public static class ChoiceCodes
        {
            public static class TestPerformed
            {
                public static string Yes = "STP_TP_Y";

                public static string NotDocumented = "STP_TP_ND";
            }

            public static class TestResult
            {
                public static string Normal = "STP_TR_N";

                public static string Abnormal = "STP_TR_A";
            }
        }
    }
}