﻿<%@ Page Title="" Language="C#" MasterPageFile="~/RegistryNoLeftMenu.master" AutoEventWireup="true" CodeFile="Encounter.aspx.cs" Inherits="Encounter" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>
<%@ Register Src="~/controls/ExamTabv2/ExamTabUserControl.ascx" TagName="ExamTabUserControl" TagPrefix="mevir" %>
<%@ Register Src="~/controls/EncounterInformationUserControl.ascx" TagName="EncounterInformationUserControl" TagPrefix="mevir" %>
<%@ Register Src="~/controls/ReviewComment/ReviewCommentListingControl.ascx" TagName="ReviewCommentListing" TagPrefix="mevir" %>
<%@ Register Src="~/controls/ReviewComment/ReviewerCommentControl.ascx" TagName="ReviewComment" TagPrefix="mevir" %>
<%@ Register Src="~/controls/EncounterProviderTab/EncounterProviderControl.ascx" TagName="EncounterProviderTabControl" TagPrefix="mevir" %>
<%@ Register Src="~/controls/ChiefComplaintTab/ChiefComplaintControl.ascx" TagName="ChiefComplaintTabControl" TagPrefix="mevir" %>
<%@ Register Src="~/controls/EncounterDiagnosis/EncounterDiagnosisControl.ascx" TagName="DiagnosisTabControl" TagPrefix="mevir" %>
<%@ Register Src="~/controls/EncounterProcedureTab/EncounterProcedureControl.ascx" TagName="ProcedureTabControl" TagPrefix="mevir" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <telerik:RadCodeBlock runat="server" ID="rcb1">
        <script type="text/javascript">
            function ShowProgress() {
                setTimeout(function () {
                    var modal = $('<div />');
                    modal.addClass("modal");
                    $('body').append(modal);
                    var loading = $(".loading");
                    loading.show();
                    var top = Math.max($(window).height() / 2 - loading[0].offsetHeight / 2, 0);
                    var left = Math.max($(window).width() / 2 - loading[0].offsetWidth / 2, 0);
                    loading.css({ top: top, left: left });
                }, 200);
            }
        </script>
    </telerik:RadCodeBlock>
</asp:Content>
<asp:Content ID="LeftZone" ContentPlaceHolderID="LeftZoneContent" runat="Server">
    <telerik:RadSkinManager ID="RadSkinManager1" runat="server" Skin="Office2010Blue" ShowChooser="false">
    </telerik:RadSkinManager>

    <div class="leftZone">
        <a href="ReferralEncounters.aspx?id=<%=referralId%>" title="Click to go back to encounter listing for referral id: <%=referralId%>">Back to Encounter Listing
        </a>
        <br />
        <br />
        Encounter Actions<br />

        <%--These actions will be shown through a factory pattern that will accept the current status of the encounter and the role of use.--%>

        <%--TODO: Create a class for values for these operation modes--%>
        <div id="toolBarContainer" style="padding-left: 8px; padding-right: 8px;">
            <telerik:RadToolBar ID="rtbAvailalbleOperations" runat="server" Orientation="Vertical" Width="100%" OnClientButtonClicked="ShowProgress" OnButtonClick="rtbAvailalbleOperations_ButtonClick">
                <Items>
                    <telerik:RadToolBarButton Value="1" Text="Save" Font-Bold="true" ToolTip="Save Encounter Record"></telerik:RadToolBarButton>
                    <%--<telerik:RadToolBarButton IsSeparator="true"></telerik:RadToolBarButton>--%>
                    <telerik:RadToolBarButton Value="2" Text="Send for Review" Font-Bold="true" ToolTip="Encounter Record is Ready for Review (Send to Reviewer)"></telerik:RadToolBarButton>
                    <%--<telerik:RadToolBarButton IsSeparator="true"></telerik:RadToolBarButton>--%>
                    <telerik:RadToolBarButton Value="3" Text="Return to Abstractor" Font-Bold="true" ToolTip="Encounter Record has been reviewed, comments added, and ready to send back to Data Abstractor for correction."></telerik:RadToolBarButton>
                    <%--<telerik:RadToolBarButton IsSeparator="true"></telerik:RadToolBarButton>--%>
                    <telerik:RadToolBarButton Value="4" Text="Send to DVEIVR" Font-Bold="true" ToolTip="Encounter Record has been reviewed and is ready to send to DVEIVR."></telerik:RadToolBarButton>
                    <%--<telerik:RadToolBarButton IsSeparator="true"></telerik:RadToolBarButton>--%>
                    <telerik:RadToolBarButton Value="5" Text="Cancel" Font-Bold="true" ToolTip="Cancel Encounter Editing and return to Encounter Listing Page"></telerik:RadToolBarButton>
                </Items>
            </telerik:RadToolBar>
        </div>
    </div>
    <br />
</asp:Content>
<asp:Content ID="MainContentZone" ContentPlaceHolderID="MainContentPlaceHolder" runat="Server">
    <asp:ScriptManager runat="server" ID="scriptManager"></asp:ScriptManager>
    <telerik:RadAjaxManager ID="RadAjaxManager1" runat="server" />
    <asp:Label ID="LabelSaveStatusMessage" CssClass="SaveSatusLabel" Visible="false" runat="server" ForeColor="Red" Text="" />

    <%--<uc1:errorlist id="ErrorList1" runat="server" />--%>
    <%--<table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
            <td>
                <asp:Panel ID="PanelEncounterButtonsTop" runat="server" Visible="false">
                    <asp:Button ID="ButtonCloseEncounterDetails" runat="server" Text="Return to Patient's Encounter List" ToolTip="Select to return to Patient's Encounter List" OnClick="ButtonCloseEncounter_Click" UseSubmitBehavior="false" />
                </asp:Panel>
                &nbsp;
            </td>
            <asp:TableCell Visible="false" runat="server" ID="tableCellForButtonSendForReviewTop" HorizontalAlign="Right">
            </asp:TableCell>
            <asp:TableCell Visible="false" runat="server" ID="tableCellForButtonSendBackToAbstractorTop" HorizontalAlign="Right">
            </asp:TableCell>
            <asp:TableCell Visible="false" runat="server" ID="tableCellForButtonApproveForSendToDVEIRTop" HorizontalAlign="Right">
            </asp:TableCell>
            <td align="right" style="padding-right: 45px">
                <asp:Button ID="ButtonSendForReviewTop" CssClass="actionButton" runat="server" Text=" Send For Review " ToolTip="Select to Send for Review" OnClick="ButtonSendForReview_Click" />
                <asp:Button ID="ButtonSendBackToAbstractorTop" CssClass="actionButton" runat="server" Text=" Send Back to Abstractor " ToolTip="Select to Send Back to Abstractor" OnClick="ButtonSendBackToAbstractor_Click" />
                <asp:Button ID="ButtonApproveForSendToDVEIRTop" CssClass="actionButton" runat="server" Text=" Ready to Send " ToolTip="Select to Send to DVEIVR" OnClick="ButtonApproveForSendToDVEIR_Click" />
                <asp:Button ID="ButtonSaveTop" CssClass="actionButton" runat="server" Text="   Save   " ToolTip="Select to Save Referral" OnClick="ButtonSave_Click" />
                <asp:Button ID="ButtonCancelTop" runat="server" Text="  Cancel  " ToolTip="Select to Cancel and return to Referral list" OnClick="ButtonCancel_Click" CausesValidation="False" />
            </td>
        </tr>
    </table>--%>

    <telerik:RadTabStrip ID="rtsTabStrip" runat="server" MultiPageID="rmpTabContent" CausesValidation="false">
        <Tabs>
            <telerik:RadTab TabIndex="0" Text="General" Selected="true"></telerik:RadTab>
            <telerik:RadTab TabIndex="1" Text="Provider"></telerik:RadTab>
            <telerik:RadTab TabIndex="2" Text="Chief Complaint"></telerik:RadTab>
            <telerik:RadTab TabIndex="3" Text="Exam"></telerik:RadTab>
            <telerik:RadTab TabIndex="4" Text="Diagnosis (ICD)"></telerik:RadTab>
            <telerik:RadTab TabIndex="5" Text="Procedures (ICD &amp; CPT4)"></telerik:RadTab>
        </Tabs>
    </telerik:RadTabStrip>
    <telerik:RadMultiPage runat="server" ID="rmpTabContent" SelectedIndex="0">
        <telerik:RadPageView ID="rpvGeneralContent" runat="server">
            <div style="padding: 2px;">
                <br />
                <mevir:EncounterInformationUserControl ID="EncounterInfo" runat="server" />
                <br />
                <mevir:ReviewCommentListing ID="CommentListing" runat="server" OnReviewCommentListSelection="CommentListing_OnReviewCommentListSelection" />
            </div>
        </telerik:RadPageView>
        <telerik:RadPageView ID="rpvProviderContent" runat="server">
            <div style="padding: 2px;">
                <br />
                <mevir:EncounterProviderTabControl ID="ProviderTabControl" runat="server" />
            </div>
        </telerik:RadPageView>
        <telerik:RadPageView ID="rpvChiefComplaintContent" runat="server">
            <div style="padding: 2px;">
                <br />
                <mevir:ChiefComplaintTabControl ID="complaintTabUserControl" runat="server" />
            </div>
        </telerik:RadPageView>
        <telerik:RadPageView ID="rpvExamContent" runat="server">
            <div style="padding: 2px;">
                <br />
                <mevir:ExamTabUserControl ID="ExamTabUserControl" runat="server" OnEventSavedSuccessfully="ExamTabUserControl_OnEventSavedSuccessfully" />
            </div>
        </telerik:RadPageView>
        <telerik:RadPageView ID="rpvDiagnosisContent" runat="server">
            <div style="padding: 2px;">
                <br />
                <mevir:DiagnosisTabControl ID="diagnosisTabControl" runat="server" />
            </div>
        </telerik:RadPageView>
        <telerik:RadPageView ID="rpvProceduresContent" runat="server">
            <div style="padding: 2px;">
                <br />
                <mevir:ProcedureTabControl ID="procedureTabControl" runat="server" />
            </div>
        </telerik:RadPageView>
    </telerik:RadMultiPage>
    <br />
    <br />
    <div class="loading" align="center">
        Loading. Please wait.<br />
        <br />
        <img src="images/ajax-loader.gif" alt="Loading Image" />
    </div>
</asp:Content>
