﻿<%@ Page Title="" Language="C#" MasterPageFile="~/RegistryNoLeftMenu.master" AutoEventWireup="true" CodeFile="Referrals.aspx.cs" Inherits="Referrals" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <telerik:RadCodeBlock runat="server" ID="rcb1">
        <script type="text/javascript">
            function ShowProgress() {
                setTimeout(function () {
                    var modal = $('<div />');
                    modal.addClass("modal");
                    $('body').append(modal);
                    var loading = $(".loading");
                    loading.show();
                    var top = Math.max($(window).height() / 2 - loading[0].offsetHeight / 2, 0);
                    var left = Math.max($(window).width() / 2 - loading[0].offsetWidth / 2, 0);
                    loading.css({ top: top, left: left });
                }, 200);
            }

            function OnGridCommand(sender, args) {
                if (args.get_commandName() == "Page" || args.get_commandName() == "Sort")
                    ShowProgress();
            }
        </script>
    </telerik:RadCodeBlock>
</asp:Content>
<asp:Content ID="LeftContent" ContentPlaceHolderID="LeftZoneContent" runat="server">
    <%--Master Pages Leave off at Tab Index 5 ... start at 10--%>
    <telerik:RadScriptManager ID="RadScriptManager1" runat="server">
        <Scripts>
            <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.Core.js"></asp:ScriptReference>
            <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQuery.js"></asp:ScriptReference>
            <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQueryInclude.js"></asp:ScriptReference>
        </Scripts>
    </telerik:RadScriptManager>

    <telerik:RadSkinManager ID="RadSkinManager1" runat="server" Skin="Office2010Blue">
    </telerik:RadSkinManager>

    <div class="leftZone">
        <asp:Label ID="lblFiltersArea" runat="server" Text="Filters / Actions" TabIndex="0" ToolTip="This section contains filters and actions available for the current page" />
        <br />
        <br />
        <div style="padding-left: 10px;">
            <asp:Label ID="lblVISN" runat="server" Text="Referral VISN: " AssociatedControlID="rcbVISN" /><br />
            <telerik:RadComboBox ID="rcbVISN" runat="server" Width="230px" AccessKey="v" TabIndex="0" AutoPostBack="true" OnClientSelectedIndexChanged="ShowProgress" OnSelectedIndexChanged="rcbVISN_SelectedIndexChanged" Enabled="true" />

            <br />
            <br />
            <asp:Label ID="lblFacility" runat="server" Text="Referral Facility: " AssociatedControlID="rcbFac" /><br />
            <telerik:RadComboBox ID="rcbFac" runat="server" Width="230px" AccessKey="v" TabIndex="0" EmptyMessage="Select a Facility" AutoPostBack="true" OnSelectedIndexChanged="rcbFac_SelectedIndexChanged" OnClientSelectedIndexChanged="ShowProgress" Enabled="false" />

            <br />
            <br />
            <asp:Label ID="lblName" runat="server" Text="Patient Name or SSN: " AssociatedControlID="rtbPatientNameSSN" /><br />
            <telerik:RadTextBox ID="rtbPatientNameSSN" runat="server" Width="230px" AccessKey="v" TabIndex="0" EmptyMessage="Enter Patient Name or SSN" Enabled="true" />

            <br />
            <br />
            <asp:Label ID="lblReferralType" runat="server" Text="Referral-Encounter Status:  " AssociatedControlID="rcbReferralType" /><br />
            <telerik:RadComboBox ID="rcbReferralType" runat="server" Width="230px" AutoPostBack="false" ToolTip="Limit returned Referrals to those that contain Encounters with the selected status."
                OnSelectedIndexChanged="rcbReferralType_SelectedIndexChanged" TabIndex="0">
                <Items>
                    <telerik:RadComboBoxItem Text="All" Value="all" Selected="true" />
                    <telerik:RadComboBoxItem Text="New" Value="new" />
                    <telerik:RadComboBoxItem Text="In Process" Value="inproc" />
                    <telerik:RadComboBoxItem Text="Returned" Value="returned" />
                    <telerik:RadComboBoxItem Text="Ready for Review" Value="review" />
                    <telerik:RadComboBoxItem Text="Ready to Send" Value="send" />
                    <telerik:RadComboBoxItem Text="Completed" Value="completed" />
                </Items>
            </telerik:RadComboBox>

            <br />
            <br />
            <telerik:RadButton ID="rbSearch" runat="server" Text="Search" ToolTip="Click to run search for selected filters" OnClick="rbSearch_Click" OnClientClicked="ShowProgress" TabIndex="0" />
        </div>
    </div>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContentPlaceHolder" runat="Server">
    <br />
    <%--Start Tab Index at 50--%>
    <telerik:RadGrid ID="rgReferrals" runat="server" AllowPaging="True" AllowSorting="True" GroupPanelPosition="Top" OnItemCommand="rgReferrals_ItemCommand"
        OnNeedDataSource="rgReferrals_NeedDataSource" AllowMultiRowSelection="false" PagerStyle-AlwaysVisible="true" TabIndex="0">
        <MasterTableView AutoGenerateColumns="false" DataKeyNames="REFERRAL_ID" PageSize="20" TabIndex="0">
            <NoRecordsTemplate>
                <table>
                    <tr>
                        <td>
                            <asp:Label ID="lblNoRecords" runat="server" Style="color: red; font-size: 12pt; font-weight: normal;">
                                Either no results were found with the selected parameters or the initial search has not been performed yet.  Please select filters to the left.
                            </asp:Label>
                        </td>
                    </tr>
                </table>
            </NoRecordsTemplate>
            <SortExpressions>
                <telerik:GridSortExpression FieldName="PatientName" SortOrder="Ascending" />
            </SortExpressions>
            <Columns>
                <telerik:GridButtonColumn CommandName="Details" ButtonType="LinkButton" Text="Select" HeaderText="Select"></telerik:GridButtonColumn>
                <telerik:GridBoundColumn DataField="REFERRAL_ID" DataType="System.Int32" FilterControlAltText="Filter REFERRAL_ID column" HeaderText="REFERRAL_ID" ReadOnly="True" SortExpression="REFERRAL_ID" UniqueName="REFERRAL_ID_Report">
                </telerik:GridBoundColumn>
                <telerik:GridBoundColumn DataField="STD_REFERRALSTS_ID" DataType="System.Int32" FilterControlAltText="Filter STD_REFERRALSTS_ID column" HeaderText="STD_REFERRALSTS_ID" ReadOnly="True" SortExpression="STD_REFERRALSTS_ID" UniqueName="STD_REFERRALSTS_ID_Report">
                </telerik:GridBoundColumn>
                <telerik:GridBoundColumn DataField="REFERRAL_DATE" DataType="System.DateTime" FilterControlAltText="Filter REFERRAL DATE column" HeaderText="REFERRAL DATE" ReadOnly="True" SortExpression="REFERRAL_DATE" UniqueName="REFERRAL_DATE_Report">
                </telerik:GridBoundColumn>
                <telerik:GridBoundColumn DataField="PatientSSN" DataType="System.String" FilterControlAltText="Filter SSN column" HeaderText="SSN" ReadOnly="True" SortExpression="PatientSSN" UniqueName="PatientSSN_Report">
                </telerik:GridBoundColumn>
                <telerik:GridBoundColumn DataField="PatientName" DataType="System.String" FilterControlAltText="Filter Patient Name column" HeaderText="Patient Name" ReadOnly="True" SortExpression="PatientName" UniqueName="PatientName_Report">
                </telerik:GridBoundColumn>
                <telerik:GridBoundColumn DataField="STATIONNUMBER" DataType="System.String" FilterControlAltText="Filter STATIONNUMBER column" HeaderText="STATION NUMBER" ReadOnly="True" SortExpression="STATIONNUMBER" UniqueName="STATIONNUMBER_Report">
                </telerik:GridBoundColumn>
                <telerik:GridBoundColumn DataField="VISN_NAME" DataType="System.String" FilterControlAltText="Filter VISN NAME column" HeaderText="VISN NAME" ReadOnly="True" SortExpression="VISN_NAME" UniqueName="VISN_NAME_Report">
                </telerik:GridBoundColumn>

                <telerik:GridBoundColumn DataField="TotalEncounterCount" DataType="System.Int32" FilterControlAltText="Filter Total Encounter Count column" HeaderText="Total Encounter Count" ReadOnly="True" SortExpression="TotalEncounterCount" UniqueName="TotalEncounterCount_Report">
                </telerik:GridBoundColumn>

                <%--<telerik:GridBoundColumn DataField="TotalEncounterCount" DataType="System.Int32" FilterControlAltText="Filter Total Encounter Count column" HeaderText="Total Encounter Count" ReadOnly="True" SortExpression="TotalEncounterCount" UniqueName="TotalEncounterCount_Report">
                </telerik:GridBoundColumn>

                <telerik:GridBoundColumn DataField="OpenEncounterCount" DataType="System.Int32" FilterControlAltText="Filter Open Encounter Count column" HeaderText="Open Encounter Count" ReadOnly="True" SortExpression="OpenEncounterCount" UniqueName="OpenEncounterCount_Report">
                </telerik:GridBoundColumn>--%>
            </Columns>
        </MasterTableView>
        <ClientSettings AllowKeyboardNavigation="true">
            <ClientEvents OnCommand="OnGridCommand" />
            <KeyboardNavigationSettings EnableKeyboardShortcuts="true"></KeyboardNavigationSettings>
            <Selecting AllowRowSelect="true" />
        </ClientSettings>
    </telerik:RadGrid>

    <div class="loading" align="center">
        Loading. Please wait.<br />
        <br />
        <img src="images/ajax-loader.gif" alt="Loading Image" />
    </div>
</asp:Content>
