﻿using DataAccess;
using Managers.Encounter;
using System;
using System.Web.UI;
using VeteransAffairs.Registries.BusinessManager;

public partial class controls_ChiefComplaintTab_ChiefComplaintControl : System.Web.UI.UserControl
{
    public ER_ENCOUNTER_MOD Encounter { get; set; }
    public UserAccountManager CurrentUser { get; set; }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Encounter != null)
            {
                //Populate Complaint
                txtChiefComplaint.Text = Encounter.CHIEF_COMPLAINT_TEXT;

                //Populate Checkboxes
                TBI_IND.Checked = (Encounter.TBI_IND == "1") ? true : false;
                TBI_READ_PRBLM_IND.Checked = (Encounter.TBI_READ_PRBLM_IND == "1") ? true : false;
                TBI_DIPLOPIA_IND.Checked = (Encounter.TBI_DIPLOPIA_IND == "1") ? true : false;
                TBI_DAZZLING_IND.Checked = (Encounter.TBI_DAZZLING_IND == "1") ? true : false;
                TBI_PHOTOPHOBIA_IND.Checked = (Encounter.TBI_PHOTOPHOBIA_IND == "1") ? true : false;
                TBI_EYE_STRAIN_IND.Checked = (Encounter.TBI_EYE_STRAIN_IND == "1") ? true : false;
                TBI_BLURRED_VISION_IND.Checked = (Encounter.TBI_BLURRED_VISION_IND == "1") ? true : false;
                OTHER_NEUROLOGICAL_IND.Checked = (Encounter.OTHER_NEUROLOGICAL_IND == "1") ? true : false;

                //Populate Comments
                txtComments.Text = Encounter.NEUROLOGICAL_COMMENT_TEXT;
            }
        }

        // Review Comments
        if (Encounter != null)
        {
            rccChiefComplaint.EncounterId = Encounter.ER_ENCOUNTER_ID;
            rccChiefComplaint.QuestionCode = "ENC_CHIEFCOMP";
            rccChiefComplaint.AnchorId = ReviewCommentAnchorType.ENCOUNTER_CHIEF_COMPLAINT_TAB;
            rccChiefComplaint.FriendlyLocationName = "Chief Complaint Tab > Chief Complaint";
            rccChiefComplaint.IsCommentEditable = true;
            //rccChiefComplaint.SetFocusOnLoad
            rccChiefComplaint.CurrentUser = CurrentUser;
            
            rccChiefComplaint.EncounterStatusID = (Encounter.EncounterStatusID != null) ? (int)Encounter.EncounterStatusID : 0;

            if (!IsPostBack)
            {
                rccChiefComplaint.ShowCommentControl = true;
                rccChiefComplaint.ShowCommentsOnLoad = false;
                rccChiefComplaint.LoadControlsFromObject();
            }

            //rccChiefComplaint.IsResolvedEditable
            //rccChiefComplaint.IsApproveEditable

            rccVisualConditions.EncounterId = Encounter.ER_ENCOUNTER_ID;
            rccVisualConditions.QuestionCode = "ENC_VIS_COND";
            rccVisualConditions.AnchorId = ReviewCommentAnchorType.ENCOUNTER_CHIEF_COMPLAINT_TAB;
            rccVisualConditions.FriendlyLocationName = "Chief Complaint Tab > Visual Conditions";
            rccVisualConditions.IsCommentEditable = true;
            rccVisualConditions.CurrentUser = CurrentUser;
            rccVisualConditions.EncounterStatusID = (Encounter.EncounterStatusID != null) ? (int)Encounter.EncounterStatusID : 0;

            if (!IsPostBack)
            {
                rccVisualConditions.ShowCommentControl = true;
                rccVisualConditions.ShowCommentsOnLoad = false;
                rccVisualConditions.LoadControlsFromObject();
            }
        }
    }

    public void SaveChiefComplaint(ref ER_ENCOUNTER_MOD inputEncounter)
    {
        if (inputEncounter != null)
        {
            //Set Complaint Text
            inputEncounter.CHIEF_COMPLAINT_TEXT = txtChiefComplaint.Text;

            //Set new Encounter Selections
            inputEncounter.TBI_IND = TBI_IND.Checked ? "1" : "0";
            inputEncounter.TBI_READ_PRBLM_IND = TBI_READ_PRBLM_IND.Checked ? "1" : "0";
            inputEncounter.TBI_DIPLOPIA_IND = TBI_DIPLOPIA_IND.Checked ? "1" : "0";
            inputEncounter.TBI_DAZZLING_IND = TBI_DAZZLING_IND.Checked ? "1" : "0";
            inputEncounter.TBI_PHOTOPHOBIA_IND = TBI_PHOTOPHOBIA_IND.Checked ? "1" : "0";
            inputEncounter.TBI_EYE_STRAIN_IND = TBI_EYE_STRAIN_IND.Checked ? "1" : "0";
            inputEncounter.TBI_BLURRED_VISION_IND = TBI_BLURRED_VISION_IND.Checked ? "1" : "0";
            inputEncounter.OTHER_NEUROLOGICAL_IND = OTHER_NEUROLOGICAL_IND.Checked ? "1" : "0";

            //Set Comment Text
            inputEncounter.NEUROLOGICAL_COMMENT_TEXT = txtComments.Text;
        }
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        //if (Encounter != null)
            //SaveCheifComplaint(Encounter);
    }
}