﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="EncounterDiagnosisControl.ascx.cs" Inherits="controls_EncounterDiagnosis_EncounterDiagnosisControl" %>

<%@ Register Src="~/controls/ReviewComment/ReviewerCommentControl.ascx" TagName="ReviewerCommentControl" TagPrefix="mevir" %>
<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<telerik:RadAjaxLoadingPanel ID="ralpLoadingPanel" runat="server" Skin="Office2010Blue"></telerik:RadAjaxLoadingPanel>

<telerik:RadAjaxPanel ID="rapPanelDiagnosis" runat="server" Width="100%" LoadingPanelID="ralpLoadingPanel">

    <asp:Panel ID="pnlBlindRehabRegion" runat="server" Width="100%" GroupingText="Blind Rehabilitation&nbsp;">
        <div class="paddedTabContent">
            <mevir:ReviewerCommentControl ID="rccDiagnosisBlindRehab" runat="server" />
            <asp:Label ID="lblForBlindRehab" runat="server" Text="Referred to/currently in Vision Rehabilitation" />&nbsp;
            <telerik:RadButton ID="rbBlindRehabYes" runat="server" Text="Yes" ToggleType="Radio" ButtonType="StandardButton" GroupName="BlindRehabPatient" AutoPostBack="false" />
            &nbsp;&nbsp;
            <telerik:RadButton ID="rbBlindRehabNo" runat="server" Text="No" ToggleType="Radio" ButtonType="StandardButton" GroupName="BlindRehabPatient" AutoPostBack="false" />
            &nbsp;&nbsp;
            <telerik:RadButton ID="rbBlindRehabNA" runat="server" Text="Unknown" ToggleType="Radio" ButtonType="StandardButton" GroupName="BlindRehabPatient" AutoPostBack="false" />
        </div>
    </asp:Panel>
    <br />
    <asp:Panel ID="pnlDiagnosisInformation" runat="server" Width="100%" GroupingText="Diagnosis Information&nbsp;">
        <div class="paddedTabContent">

            <asp:Panel ID="pnlAddDiagnosisBtn" runat="server" Visible="false">
                <telerik:RadButton ID="rbAddDiagnosis" runat="server" Text="Add Diagnosis" ToolTip="Click to add a Diagnosis Entry for Encounter" OnClick="rbAddDiagnosis_Click" />
                <br />
                <br />
            </asp:Panel>

            <telerik:RadGrid ID="rgDiagnosis" runat="server" AllowPaging="True" AllowSorting="True" GroupPanelPosition="Top" OnItemCommand="rgDiagnosis_ItemCommand" OnPreRender="rgDiagnosis_PreRender"
                OnNeedDataSource="rgDiagnosis_NeedDataSource" AllowMultiRowSelection="false" PageSize="20" TabIndex="0" MasterTableView-EnableSplitHeaderText="false">
                <MasterTableView AutoGenerateColumns="false" DataKeyNames="ID" ShowHeadersWhenNoRecords="true" PagerStyle-AlwaysVisible="true" TabIndex="0">
                    <NoRecordsTemplate>
                        <table>
                            <tr>
                                <td>
                                    <asp:Label ID="lblNoRecords" runat="server" Style="color: red; font-size: 12pt; font-weight: normal;" TabIndex="14">
                                No Diagnosis Records for Encounter
                                    </asp:Label>
                                </td>
                            </tr>
                        </table>
                    </NoRecordsTemplate>
                    <SortExpressions>
                        <%--<telerik:GridSortExpression FieldName="StaffName" SortOrder="Ascending" />--%>
                    </SortExpressions>
                    <Columns>
                        <telerik:GridButtonColumn ButtonType="LinkButton" Text="Edit" CommandName="EditDiagnosis" Exportable="false" HeaderText="Edit"
                            HeaderTooltip="Click to Edit the Diagnosis record." UniqueName="EditDiagnosisColumn" />
                        <telerik:GridButtonColumn ButtonType="LinkButton" Text="Delete" CommandName="DeleteDiagnosis" Exportable="false" HeaderText="Delete"
                            HeaderTooltip="Click to Delete the Diagnosis record." ConfirmText="Are you sure you would like to delete this record?" UniqueName="DeleteDiagnosisColumn" />
                        <telerik:GridBoundColumn DataField="Type" DataType="System.String" FilterControlAltText="Filter Type column" HeaderText="Code Type" ReadOnly="True" SortExpression="Type" UniqueName="Type_Report">
                        </telerik:GridBoundColumn>
                        <telerik:GridBoundColumn DataField="Value" DataType="System.String" FilterControlAltText="Filter Code column" HeaderText="Code" ReadOnly="True" SortExpression="Value" UniqueName="Value_Report">
                        </telerik:GridBoundColumn>
                        <telerik:GridBoundColumn DataField="Description" DataType="System.String" FilterControlAltText="Filter Description column" HeaderText="Code Description" ReadOnly="True" SortExpression="Description" UniqueName="Description_Report">
                        </telerik:GridBoundColumn>
                    </Columns>
                </MasterTableView>
                <ClientSettings>
                </ClientSettings>
            </telerik:RadGrid>

            <%--Used for Edit - holds the ENCOUNTER_DETAIL_ID--%>
            <asp:HiddenField ID="hfEncounterDetailID" runat="server" />

            <asp:Panel ID="pnlAddDiagnosisRegion" runat="server" GroupingText="Add Diagnosis&nbsp;&nbsp;" ToolTip="Add Diagnosis Region" Visible="false">
                <table>
                    <tr>
                        <td style="vertical-align: top;">
                            <asp:Label ID="lblForDetailCode" runat="server" AssociatedControlID="rtbDetailCode" Text="ICD Code:" ToolTip="Enter the ICD Code in the associated textbox." />
                        </td>
                        <td style="vertical-align: top;">
                            <telerik:RadTextBox ID="rtbDetailCode" runat="server" Width="200" EmptyMessage="Enter the ICD Code" ToolTip="Enter the ICD Code in this textbox" />
                            <asp:RequiredFieldValidator ID="ICDCodeRequiredFieldValidator" runat="server" Display="Dynamic" ControlToValidate="rtbDetailCode" TabIndex="0"
                                ErrorMessage="* ICD Code must be provided." ForeColor="Red" CssClass="requiredField" ToolTip="ICD Code is a required field" />
                        </td>
                    </tr>
                    <tr>
                        <td style="vertical-align: top;">
                            <asp:Label ID="lblForDescription" runat="server" AssociatedControlID="rtbDescription" Text="Description:" ToolTip="Enter the description for the ICD Code in the associated textbox." />
                        </td>
                        <td style="vertical-align: top;">
                            <telerik:RadTextBox ID="rtbDescription" runat="server" Width="200" TextMode="MultiLine" EmptyMessage="Enter the description text for the ICD Code" ToolTip="Enter the ICD Code Description in this area" />
                            <asp:RequiredFieldValidator ID="DescriptionRequiredFieldValidator" runat="server" Display="Dynamic" ControlToValidate="rtbDescription" TabIndex="0"
                                ErrorMessage="* ICD Description must be provided." ForeColor="Red" CssClass="requiredField" ToolTip="ICD Description is a required field" />
                        </td>
                    </tr>
                    <tr>
                        <td style="vertical-align: top;"></td>
                        <td style="vertical-align: top;"></td>
                    </tr>
                    <tr>
                        <td colspan="2" style="vertical-align: top;">
                            <telerik:RadButton ID="rbAddDiagnosisEntry" runat="server" Text="Add Diagnosis" ToolTip="Click to add diagnosis entry to the encounter"
                                OnClick="rbAddDiagnosisEntry_Click" TabIndex="0" />
                            <telerik:RadButton ID="rbCancelAddDiagnosisEntry" runat="server" Text="Cancel" ToolTip="Click to cancel adding diagnosis entry"
                                OnClick="rbCancelAddDiagnosisEntry_Click" TabIndex="0" CausesValidation="false" />
                        </td>
                    </tr>
                </table>
            </asp:Panel>

        </div>
    </asp:Panel>
</telerik:RadAjaxPanel>
