﻿using System;
using VeteransAffairs.Registries.Business;
using ViewModels;

namespace Controls.ExamTabv2
{
    public partial class ExamCommentsUserControl : BaseClinicalDataControl, IDynamicControl
    {
        private bool _forceRefresh;
        public TextQuestion Question { get; set; }

        public bool IsInitialLoad
        {
            get
            {
                return ViewState["TestSummaryInit"] == null ? true : (bool)ViewState["TestSummaryInit"];
            }

            set { ViewState["TestSummaryInit"] = value; }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (Question != null)
            {
                // Update view model after the first load
                if (IsInitialLoad || _forceRefresh)
                {
                    IsInitialLoad = false;
                    _forceRefresh = false;
                }
                else
                {
                    UpdateViewModel(Question);
                }

                MapViewModel();
            }
        }

        public void UpdateViewModel(TextQuestion viewModel)
        {
            // Get Comment Text
            viewModel.ResponseText = tbComments.Text;
        }

        private void MapViewModel()
        {
            // Set label and text
            lblComments.Text = Question.DisplayText;
            tbComments.Text = Question.ResponseText ?? string.Empty;
        }

        public void PerformForcedRefresh()
        {
            _forceRefresh = true;
        }

        public TextQuestion GetUpdatedQuestion()
        {
            UpdateViewModel(Question);
            return Question;
        }

        #region Depreciated Code
        // Going Away
        public EyeSettingType EyeSetting
        {
            set
            {
                if (value == EyeSettingType.RightEye
                    && !tbComments.ToolTip.Contains(" Right Eye"))
                {
                    tbComments.ToolTip = tbComments.ToolTip + " Right Eye";
                    lblComments.ToolTip = lblComments.ToolTip + " Right Eye";

                }
                else if (value == EyeSettingType.LeftEye
                         && !tbComments.ToolTip.Contains(" Left Eye"))
                {
                    tbComments.ToolTip = tbComments.ToolTip + " Left Eye";
                    lblComments.ToolTip = lblComments.ToolTip + " Left Eye";
                }
            }
        }

        // Going Away
        public string ExamTestName
        {
            set
            {

                tbComments.ToolTip = "Comments for " + value;
                lblComments.ToolTip = "Comments for " + value;
            }
        }

        // Going Away
        public string Comments
        {
            get { return tbComments.Text; }
            set { tbComments.Text = value; }
        }
        #endregion
    }
}