﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ExamTabAnteriorChamberUserControl.ascx.cs" Inherits="Controls.ExamTabv2.ExamTabAnteriorChamberUserControl" %>
<%@ Register TagPrefix="telerik" Namespace="Telerik.Web.UI" Assembly="Telerik.Web.UI" %>
<%@ Register Src="~/controls/ExamTabv2/ExamTabTestSummaryUserControl.ascx" TagName="ucTestSummary" TagPrefix="ucExamTab" %>

<div id="anteriorChamberEvent">
    <telerik:RadAjaxLoadingPanel ID="ajaxLoadingPnl" runat="server" />
    <telerik:RadAjaxManagerProxy ID="ajaxProxy" runat="server">
        <AjaxSettings>
            <telerik:AjaxSetting AjaxControlID="gvVisitData">
                <UpdatedControls>
                    <telerik:AjaxUpdatedControl ControlID="gvVisitData" LoadingPanelID="ajaxLoadingPnl"></telerik:AjaxUpdatedControl>
                </UpdatedControls>
            </telerik:AjaxSetting>
        </AjaxSettings>
    </telerik:RadAjaxManagerProxy>
    <ucExamTab:ucTestSummary runat="server" ID="ucTestSummary">
        <Contents>
            <div class="gvVisitDataWrapper">
                <asp:ValidationSummary runat="server" ID="valSummaryEdit" EnableClientScript="True" ValidationGroup="vdEdit"
                    HeaderText="Errors:" DisplayMode="BulletList" CssClass="examTabError" />
                <asp:ValidationSummary runat="server" ID="valSummaryAdd" EnableClientScript="True" ValidationGroup="vdAdd"
                    HeaderText="Errors:" DisplayMode="BulletList" CssClass="examTabError" />
                <telerik:RadGrid runat="server" ID="gvVisitData" AutoGenerateColumns="False"
                    OnItemDataBound="gvVisitData_OnItemDataBound" OnItemCommand="gvVisitData_OnItemCommand">
                    <MasterTableView AutoGenerateColumns="false" DataKeyNames="Code" EditMode="InPlace" ShowFooter="True">
                        <Columns>
                            <telerik:GridTemplateColumn HeaderText="Visit Data">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblDisplayText" Text='<%# Eval("DisplayText") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:Label runat="server" ID="Label1" Text='<%# Eval("DisplayText") %>'></asp:Label>
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <telerik:RadComboBox ID="ddlVisitData" runat="server" AllowCustomText="true"
                                        EmptyMessage="Anterior Chamber...." Filter="Contains" EnableViewState="True" CssClass="ddlVisitData"
                                        OnItemDataBound="ddlVisitData_OnItemDataBound"
                                        OnClientLoad="MEVIR.Exam.AnteriorChamber.VisitDataOnLoad"
                                        OnClientSelectedIndexChanged="MEVIR.Exam.AnteriorChamber.VisitDataSelectionChanged">
                                    </telerik:RadComboBox>
                                </FooterTemplate>
                                <ItemStyle CssClass="visitDataCol"></ItemStyle>
                                <HeaderStyle CssClass="visitDataCol"></HeaderStyle>
                                <FooterStyle CssClass="visitDataCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="Comment">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblVisitDataComment" Text='<%# Eval("Comment") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:TextBox runat="server" ID="tbVisitDataComment" ValidationGroup="vdEdit" CssClass="tbVisitDataComment" Text='<%# Bind("Comment") %>' Visible='<%# Bind("RequiresComment") %>'></asp:TextBox>
                                    <asp:RequiredFieldValidator runat="server" ID="reqValVDComment" ValidationGroup="vdEdit" CssClass="examTabError"
                                        ControlToValidate="tbVisitDataComment" Display="Dynamic" EnableClientScript="True" Enabled="False"
                                        ErrorMessage="Comment is required" />
                                    <asp:RegularExpressionValidator runat="server" ID="regExValHeight" ValidationGroup="vdEdit" CssClass="examTabError"
                                        ControlToValidate="tbVisitDataComment" Display="Dynamic" EnableClientScript="True" Enabled="False"
                                        ValidationExpression="^(?:10(\.00?)?|[1-9](\.[0-9][0-9]?)?)(\s?mm)?$" ErrorMessage="Height must be between 1.00 mm and 10.00 mm millimeters" />
                                    <asp:RegularExpressionValidator runat="server" ID="regExValPercentage" ValidationGroup="vdEdit" CssClass="examTabError"
                                        ControlToValidate="tbVisitDataComment" Display="Dynamic" EnableClientScript="True" Enabled="False"
                                        ValidationExpression="^(?:100|[1-9][0-9]?)%?" ErrorMessage="Percentage must be between 1% and 100% percent" />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <span id="visitDataCommentWrapper">
                                        <asp:TextBox runat="server" ID="tbVisitDataComment" ValidationGroup="vdAdd" CssClass="tbVisitDataComment"></asp:TextBox>
                                        <asp:RequiredFieldValidator runat="server" ID="reqValVDComment" ValidationGroup="vdAdd" CssClass="examTabError"
                                            ControlToValidate="tbVisitDataComment" Display="Static" EnableClientScript="True" Enabled="False"
                                            ErrorMessage="Comment is required" />
                                        <asp:RegularExpressionValidator runat="server" ID="regExValHeight" ValidationGroup="vdAdd" CssClass="examTabError"
                                            ControlToValidate="tbVisitDataComment" Display="Static" EnableClientScript="True" Enabled="False"
                                            ValidationExpression="^(?:10(\.00?)?|[1-9](\.[0-9][0-9]?)?)(\s?mm)?$" ErrorMessage="Height must be between 1.00 mm and 10.00 mm millimeters" />
                                        <asp:RegularExpressionValidator runat="server" ID="regExValPercentage" ValidationGroup="vdAdd" CssClass="examTabError"
                                            ControlToValidate="tbVisitDataComment" Display="Static" EnableClientScript="True" Enabled="False"
                                            ValidationExpression="^(?:100|[1-9][0-9]?)%?" ErrorMessage="Percentage must be between 1% and 100% percent" />
                                    </span>
                                </FooterTemplate>
                                <ItemStyle CssClass="visitDataCommentCol"></ItemStyle>
                                <HeaderStyle CssClass="visitDataCommentCol"></HeaderStyle>
                                <FooterStyle CssClass="visitDataCommentCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="">
                                <ItemTemplate>
                                    <asp:PlaceHolder runat="server" ID="phVDEdit" Visible='<%# Eval("RequiresComment") %>'>
                                        <asp:LinkButton runat="server" ID="lbtnVisitDataEdit" CommandName="Edit" CommandArgument='<%# Eval("Code") %>' Text="Edit" />
                                        &nbsp;
                                    </asp:PlaceHolder>
                                    <asp:LinkButton runat="server" ID="lbtnVisitDataDelete" CommandName="Delete" CommandArgument='<%# Eval("Code") %>' Text="Delete" />
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnVisitDataUpdate" ValidationGroup="vdEdit" CommandName="Update" CommandArgument='<%# Eval("Code") %>' Text="Update" />
                                    &nbsp;
                                            <asp:LinkButton runat="server" ID="lbtnVisitDataCancel" CommandName="Cancel" CommandArgument='<%# Eval("Code") %>' Text="Cancel" />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnVisitDataAdd" ValidationGroup="vdAdd" CommandName="Add" CommandArgument='<%# Eval("Code") %>' Text="Add" />
                                </FooterTemplate>
                                <ItemStyle CssClass="rowCommandCol"></ItemStyle>
                                <HeaderStyle CssClass="rowCommandCol"></HeaderStyle>
                                <FooterStyle CssClass="rowCommandCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                        </Columns>
                    </MasterTableView>
                </telerik:RadGrid>
            </div>
        </Contents>
    </ucExamTab:ucTestSummary>
</div>
