﻿using ViewModels.Exam;

namespace Controls.ExamTabv2
{
    public partial class ExamTabColorVisionUserControl : BaseEventItem<ColorVisionEventModel>
    {
        #region Implemented Methods

        protected override void MapValidationGroup()
        {
            tbNumberCorrect.ValidationGroup = ValidationGroup;
            tbTotalNumber.ValidationGroup = ValidationGroup;
            compValColorVision.ValidationGroup = ValidationGroup;
        }

        protected override void MapTestSummary()
        {
            ucTestSummary.ViewModel = EventViewModel;
            ucTestSummary.TestPerformExpandValues = ColorVisionEventModel.ShowTestDetailValues;
        }

        protected override void MapTestDetails()
        {
            // Number Correct
            tbNumberCorrect.Text = EventViewModel.NumberCorrect.ResponseText;

            // Total Number
            tbTotalNumber.Text = EventViewModel.TotalNumber.ResponseText;
        }

        protected override void PerformForcedRefresh()
        {
            // Force Refresh on child controls
            ucTestSummary.PerformForcedRefresh();
        }

        protected override ColorVisionEventModel SaveItem()
        {
            ucTestSummary.UpdateViewModel(EventViewModel);
            EventViewModel.NumberCorrect.ResponseText = tbNumberCorrect.TextWithLiterals;
            EventViewModel.TotalNumber.ResponseText = tbNumberCorrect.TextWithLiterals;

            return EventViewModel;
        }

        #endregion
    }
}