﻿using System;
using System.Linq;
using ViewModels.Exam;

namespace Controls.ExamTabv2
{
    public partial class ExamTabFunctionalTestingUserControl : BaseEventItem<FunctionalTestingEventModel>
    {
        #region Implemented Methods

        protected override void MapValidationGroup()
        {
            reqValVergenceRanges.ValidationGroup = ValidationGroup;
            ddlVergenceRangesType.ValidationGroup = ValidationGroup;
            regExValVergenceRanges.ValidationGroup = ValidationGroup;
            
            tbNearPointConvergence.ValidationGroup = ValidationGroup;
            ddlNearPointConvergenceUnit.ValidationGroup = ValidationGroup;
            reqValNearPointConvergence.ValidationGroup = ValidationGroup;
            regExValNearPointConvergence.ValidationGroup = ValidationGroup;

            tbAccommodativeAmplitude.ValidationGroup = ValidationGroup;
            reqValAccommodativeAmplitutde.ValidationGroup = ValidationGroup;
            ddlAccommodativeAmplitudeUnit.ValidationGroup = ValidationGroup;
            regExValAccommodativeAmplitude.ValidationGroup = ValidationGroup;

            tbAccommodativeRanges.ValidationGroup = ValidationGroup;
            regExValAccommodativeRanges.ValidationGroup = ValidationGroup;

            tbRefractionResults.ValidationGroup = ValidationGroup;
            regExValRefractionResults.ValidationGroup = ValidationGroup;
        }

        protected override void MapTestSummary()
        {
            ucTestSummary.ViewModel = EventViewModel;
            ucTestSummary.TestPerformExpandValues = FunctionalTestingEventModel.ShowTestDetailValues;
        }

        protected override void MapTestDetails()
        {
            // Vergence Ranges
            lblVergenceRanges.Text = EventViewModel.VergenceRanges.DisplayText;
            tbVergenceRanges.Text = EventViewModel.VergenceRanges.ResponseText;
            MapSelectField(ddlVergenceRangesType, EventViewModel.VergenceRangesType);

            // Near Point of Convergence
            lblNearPointConvergence.Text = EventViewModel.NearPointConvergence.DisplayText;
            tbNearPointConvergence.Text = EventViewModel.NearPointConvergence.ResponseText;
            MapSelectField(ddlNearPointConvergenceUnit, EventViewModel.NearPointConvergenceUnit);

            // Accommodative Amplitude
            lblAccommodativeAmplitude.Text = EventViewModel.AccommodativeAmplitude.DisplayText;
            tbAccommodativeAmplitude.Text = EventViewModel.AccommodativeAmplitude.ResponseText;
            MapSelectField(ddlAccommodativeAmplitudeUnit, EventViewModel.AccommodativeAmplitudeUnit);

            // Accommodative Ranges
            lblAccommodativeRanges.Text = EventViewModel.AccommodativeRanges.DisplayText;
            tbAccommodativeRanges.Text = EventViewModel.AccommodativeRanges.ResponseText;

            // Refraction Results
            lblRefractionResults.Text = EventViewModel.RefractionResults.DisplayText;
            tbRefractionResults.Text = EventViewModel.RefractionResults.ResponseText;
        }

        protected override void PerformForcedRefresh()
        {
            // Force Refresh on child controls
            ucTestSummary.PerformForcedRefresh();
        }

        protected override FunctionalTestingEventModel SaveItem()
        {
            ucTestSummary.UpdateViewModel(EventViewModel);

            // Vergence Ranges
            string vrType = ddlVergenceRangesType.SelectedValue;
            EventViewModel.VergenceRangesType.SelectedChoice =
                EventViewModel.VergenceRangesType.AllChoices.FirstOrDefault(c => c.Code == vrType);
            EventViewModel.VergenceRanges.ResponseText = tbVergenceRanges.TextWithLiterals;

            // Near Point of Convergence
            string npcUnit = ddlNearPointConvergenceUnit.SelectedValue;
            EventViewModel.NearPointConvergence.ResponseText = tbNearPointConvergence.TextWithLiterals;
            EventViewModel.NearPointConvergenceUnit.SelectedChoice =
                EventViewModel.NearPointConvergenceUnit.AllChoices.FirstOrDefault(c => c.Code == npcUnit);

            // Accommodative Amplitude
            string aaUnit = ddlAccommodativeAmplitudeUnit.SelectedValue;
            EventViewModel.AccommodativeAmplitude.ResponseText = tbAccommodativeAmplitude.TextWithLiterals;
            EventViewModel.AccommodativeAmplitudeUnit.SelectedChoice =
                EventViewModel.AccommodativeAmplitudeUnit.AllChoices.FirstOrDefault(c => c.Code == aaUnit);

            // Accommodative Ranges
            EventViewModel.AccommodativeRanges.ResponseText = tbAccommodativeRanges.TextWithLiterals;

            // Refraction Results
            EventViewModel.RefractionResults.ResponseText = tbRefractionResults.TextWithLiterals;

            return EventViewModel;
        }

        #endregion
    }
}