﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ExamTabImagingMethodologyUserControl.ascx.cs" Inherits="Controls.ExamTabv2.ExamTabImagingMethodologyUserControl" %>
<%@ Register TagPrefix="telerik" Namespace="Telerik.Web.UI" Assembly="Telerik.Web.UI" %>
<%@ Register Src="~/controls/ExamTabv2/ExamTabTestSummaryUserControl.ascx" TagName="ucTestSummary" TagPrefix="ucExamTab" %>

<div id="imagingAncillaryEvent">
    <telerik:RadAjaxLoadingPanel ID="ajaxLoadingPnl" runat="server" />
    <telerik:RadAjaxManagerProxy ID="ajaxProxy" runat="server">
        <AjaxSettings>
            <telerik:AjaxSetting AjaxControlID="gvImagingMethodology">
                <UpdatedControls>
                    <telerik:AjaxUpdatedControl ControlID="gvImagingMethodology" LoadingPanelID="ajaxLoadingPnl"></telerik:AjaxUpdatedControl>
                </UpdatedControls>
            </telerik:AjaxSetting>
        </AjaxSettings>
    </telerik:RadAjaxManagerProxy>
    <ucExamTab:ucTestSummary runat="server" ID="ucTestSummary">
        <Contents>
            <div class="gvImagingMethodologyWrapper">
                <asp:ValidationSummary runat="server" ID="valSummaryAdd" EnableClientScript="True" ValidationGroup="imAdd"
                    HeaderText="Errors:" DisplayMode="BulletList" CssClass="examTabError" />
                <asp:ValidationSummary runat="server" ID="valSummaryEdit" EnableClientScript="True" ValidationGroup="imEdit"
                    HeaderText="Errors:" DisplayMode="BulletList" CssClass="examTabError" />
                <telerik:RadGrid runat="server" ID="gvImagingMethodology" AutoGenerateColumns="False"
                    OnItemDataBound="gvImagingMethodology_OnItemDataBound" OnItemCommand="gvImagingMethodology_OnItemCommand">
                    <MasterTableView AutoGenerateColumns="false" EditMode="InPlace" ShowFooter="True">
                        <Columns>
                            <telerik:GridTemplateColumn HeaderText="Imaging Methodology">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblDisplayText" Text='<%# Eval("DisplayText") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:Label runat="server" ID="lblDisplayText" Text='<%# Eval("DisplayText") %>'></asp:Label>
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <telerik:RadComboBox ID="ddlImagingMethodology" runat="server" AllowCustomText="true"
                                        EmptyMessage="Imaging Methodology...." Filter="Contains" EnableViewState="True" CssClass="ddlImagingMethodology"
                                        OnItemDataBound="ddlImagingMethodology_OnItemDataBound"
                                        OnClientLoad="MEVIR.Exam.ImagingAncillary.ImagingMethodologyOnLoad"
                                        OnClientSelectedIndexChanged="MEVIR.Exam.ImagingAncillary.ImagingMethodologyOnLoad">
                                    </telerik:RadComboBox>
                                </FooterTemplate>
                                <ItemStyle CssClass="imagingMethodologyCol"></ItemStyle>
                                <HeaderStyle CssClass="imagingMethodologyCol"></HeaderStyle>
                                <FooterStyle CssClass="imagingMethodologyCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="Comment">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblMethodologyComment" Text='<%# Eval("Comment") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:TextBox runat="server" ID="tbMethodologyComment" CssClass="tbMethodologyComment" Text='<%# Bind("Comment") %>'
                                        Visible='<%# Bind("RequiresComment") %>' />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <span id="methodologyCommentWrapper">
                                        <asp:TextBox runat="server" ID="tbMethodologyComment" CssClass="tbMethodologyComment"></asp:TextBox>
                                    </span>
                                </FooterTemplate>
                                <ItemStyle CssClass="methodologyCommentCol"></ItemStyle>
                                <HeaderStyle CssClass="methodologyCommentCol"></HeaderStyle>
                                <FooterStyle CssClass="methodologyCommentCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="Test Date">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblTestDate" Text='<%# Eval("TestDate") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <telerik:RadDatePicker runat="server" ID="tbTestDate" ValidationGroup="imAdd" CssClass="tbTestDate"
                                        DateInput-DateFormat="d" ShowPopupOnFocus="True" DateInput-EmptyMessage="Test Date"
                                        ShowAnimation-Type="Fade" ShowAnimation-Duration="300" />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <telerik:RadDatePicker runat="server" ID="tbTestDate" ValidationGroup="imAdd" CssClass="tbTestDate"
                                        DateInput-DateFormat="d" ShowPopupOnFocus="True" DateInput-EmptyMessage="Test Date"
                                        ShowAnimation-Type="Fade" ShowAnimation-Duration="300" />
                                </FooterTemplate>
                                <ItemStyle CssClass="testDateCol"></ItemStyle>
                                <HeaderStyle CssClass="testDateCol"></HeaderStyle>
                                <FooterStyle CssClass="testDateCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="Test Result">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblTestResult" Text='<%# Eval("TestResult") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:RequiredFieldValidator runat="server" ID="reqValTestResult" ValidationGroup="imEdit" CssClass="examTabError"
                                        ControlToValidate="tbTestResult" Display="Dynamic" EnableClientScript="True" Enabled="True"
                                        Text="*" ErrorMessage="TEST RESULT Is Required!" />
                                    <asp:TextBox runat="server" ID="tbTestResult" CssClass="tbTestResult" Text='<%# Bind("TestResult") %>'></asp:TextBox>
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <asp:RequiredFieldValidator runat="server" ID="reqValTestResult" ValidationGroup="imAdd" CssClass="examTabError"
                                        ControlToValidate="tbTestResult" Display="Dynamic" EnableClientScript="True" Enabled="False"
                                        Text="*" ErrorMessage="TEST RESULT Is Required!" />
                                    <asp:TextBox runat="server" ID="tbTestResult" CssClass="tbTestResult" />
                                </FooterTemplate>
                                <ItemStyle CssClass="testResultCol"></ItemStyle>
                                <HeaderStyle CssClass="testResultCol"></HeaderStyle>
                                <FooterStyle CssClass="testResultCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="">
                                <ItemTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnVisitDataEdit" CommandName="Edit" Text="Edit" />
                                    &nbsp;
                                            <asp:LinkButton runat="server" ID="lbtnVisitDataDelete" CommandName="Delete" Text="Delete" />
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnVisitDataUpdate" ValidationGroup="imEdit" CommandName="Update" Text="Update" />
                                    &nbsp;
                                            <asp:LinkButton runat="server" ID="lbtnVisitDataCancel" CommandName="Cancel" Text="Cancel" />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnVisitDataAdd" ValidationGroup="imAdd" CommandName="Add" Text="Add" />
                                </FooterTemplate>
                                <ItemStyle CssClass="rowCommandCol"></ItemStyle>
                                <HeaderStyle CssClass="rowCommandCol"></HeaderStyle>
                                <FooterStyle CssClass="rowCommandCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                        </Columns>
                    </MasterTableView>
                </telerik:RadGrid>
            </div>
        </Contents>
    </ucExamTab:ucTestSummary>
</div>
