﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ExamTabMotilityUserControl.ascx.cs" Inherits="Controls.ExamTabv2.ExamTabMotilityUserControl" %>
<%@ Register TagPrefix="telerik" Namespace="Telerik.Web.UI" Assembly="Telerik.Web.UI" %>
<%@ Register Src="~/controls/ExamTabv2/ExamTabTestSummaryUserControl.ascx" TagName="ucTestSummary" TagPrefix="ucExamTab" %>
<%@ Register Src="~/controls/ExamTabv2/ExamMultiSelectUserControl.ascx" TagName="ucMultiSelect" TagPrefix="ucExamTab" %>
<%@ Register Src="~/controls/ExamTabv2/ExamSingleSelectUserControl.ascx" TagName="ucSingleSelect" TagPrefix="ucExamTab" %>

<div id="motilityEvent">
    <telerik:RadAjaxLoadingPanel ID="ajaxLoadingPnl" runat="server" />
    <telerik:RadAjaxManagerProxy ID="ajaxProxy" runat="server">
        <AjaxSettings>
            <telerik:AjaxSetting AjaxControlID="gvMotility">
                <UpdatedControls>
                    <telerik:AjaxUpdatedControl ControlID="gvMotility" LoadingPanelID="ajaxLoadingPnl"></telerik:AjaxUpdatedControl>
                </UpdatedControls>
            </telerik:AjaxSetting>
        </AjaxSettings>
    </telerik:RadAjaxManagerProxy>
    <ucExamTab:ucTestSummary runat="server" ID="ucTestSummary">
        <Contents>
            <div class="examTabColumn">
                <div class="examTabColumnLabel">
                    <asp:Label runat="server" ID="lblPursuit" AssociatedControlID="ucPursuit"></asp:Label>
                </div>
                <div class="examTabColumnItem">
                    <ucExamTab:ucSingleSelect runat="server" ID="ucPursuit" CssClass="pursuitWrapper" />
                </div>
            </div>
            <div class="examTabColumn">
                <div class="examTabColumnLabel">
                    <asp:Label runat="server" ID="lblSaccades" AssociatedControlID="ucSaccades"></asp:Label>
                </div>
                <div class="examTabColumnItem">
                    <ucExamTab:ucSingleSelect runat="server" ID="ucSaccades" CssClass="saccadesWrapper" />
                </div>
            </div>
            <div class="clearFloat"></div>
            <div class="examTabColumn">
                <div class="examTabColumnLabel">
                    <asp:Label runat="server" ID="lblNystagmus" AssociatedControlID="ucNystagmus"></asp:Label>
                </div>
                <div class="examTabColumnItem">
                    <ucExamTab:ucSingleSelect runat="server" ID="ucNystagmus" CssClass="nystagmusWrapper"
                        OnClientLoad="MEVIR.Exam.Motility.NystagmusOnLoad"
                        OnClientSelectedIndexChanged="MEVIR.Exam.Motility.NystagmusSelectionChanged" />
                </div>
            </div>
            <div class="clearFloat"></div>
            <div id="nystagmusOptionsWrapper" class="examTabColumnDouble">
                <ucExamTab:ucMultiSelect runat="server" ID="ucNystagmusOptions" CssClass="nystagmusOptionsWrapper" />
            </div>
            <div class="clearFloat"></div>
            <div class="motilityWrapper examTabFloatLeft">
                <asp:ValidationSummary runat="server" ID="valSummaryEdit" EnableClientScript="True" ValidationGroup="mEdit"
                    HeaderText="Errors:" DisplayMode="BulletList" CssClass="examTabError" />
                <asp:ValidationSummary runat="server" ID="valSummaryAdd" EnableClientScript="True" ValidationGroup="mAdd"
                    HeaderText="Errors:" DisplayMode="BulletList" CssClass="examTabError" />
                <telerik:RadGrid runat="server" ID="gvMotility" AutoGenerateColumns="False"
                    OnItemDataBound="gvMotility_OnItemDataBound" OnItemCommand="gvMotility_OnItemCommand">
                    <MasterTableView AutoGenerateColumns="false" DataKeyNames="Code" EditMode="InPlace" ShowFooter="True">
                        <Columns>
                            <telerik:GridTemplateColumn>
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblDisplayText" Text='<%# Eval("DisplayText") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:Label runat="server" ID="lblDisplayText" Text='<%# Eval("DisplayText") %>'></asp:Label>
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <telerik:RadComboBox ID="ddlMotility" runat="server" AllowCustomText="true"
                                        EmptyMessage="Motility..." Filter="Contains" EnableViewState="True" CssClass="ddlMotility"
                                        OnItemDataBound="ddlMotility_OnItemDataBound"
                                        OnClientLoad="MEVIR.Exam.Motility.MotilityOnLoad"
                                        OnClientSelectedIndexChanged="MEVIR.Exam.Motility.MotilitySelectionChanged">
                                    </telerik:RadComboBox>
                                </FooterTemplate>
                                <ItemStyle CssClass="motilityCol"></ItemStyle>
                                <HeaderStyle CssClass="motilityCol"></HeaderStyle>
                                <FooterStyle CssClass="motilityCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="Comment">
                                <ItemTemplate>
                                    <asp:Label runat="server" ID="lblMotilityComment" Text='<%# Eval("Comment") %>'></asp:Label>
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:TextBox runat="server" ID="tbMotilityComment" ValidationGroup="mEdit" CssClass="tbMotilityComment"
                                        Text='<%# Bind("Comment") %>' Visible='<%# Bind("RequiresComment") %>'></asp:TextBox>
                                    <asp:RegularExpressionValidator runat="server" ID="regExValMotility" ValidationGroup="mEdit" CssClass="examTabError"
                                        ControlToValidate="tbMotilityComment" Display="Dynamic" EnableClientScript="True" Enabled="False"
                                        ValidationExpression="^[1-9]\d?\s?P?D?$" ErrorMessage="Must be between 1 PD and 99 PD" />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <span id="motilityCommentWrapper">
                                        <asp:TextBox runat="server" ID="tbMotilityComment" ValidationGroup="mAdd" CssClass="tbMotilityComment"></asp:TextBox>
                                        <asp:RegularExpressionValidator runat="server" ID="regExValMotility" ValidationGroup="mAdd" CssClass="examTabError"
                                            ControlToValidate="tbMotilityComment" Display="Dynamic" EnableClientScript="True" Enabled="False"
                                            ValidationExpression="^[1-9]\d?\s?P?D?$" ErrorMessage="Must be between 1 PD and 99 PD" />
                                    </span>
                                </FooterTemplate>
                                <ItemStyle CssClass="motilityCommentCol"></ItemStyle>
                                <HeaderStyle CssClass="motilityCommentCol"></HeaderStyle>
                                <FooterStyle CssClass="motilityCommentCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                            <telerik:GridTemplateColumn HeaderText="">
                                <ItemTemplate>
                                    <asp:PlaceHolder runat="server" ID="phMotEdit" Visible='<%# Eval("RequiresComment") %>'>
                                        <asp:LinkButton runat="server" ID="lbtnMotilityEdit" CommandName="Edit" Text="Edit" />
                                        &nbsp;
                                    </asp:PlaceHolder>
                                    <asp:LinkButton runat="server" ID="lbtnMotilityDelete" CommandName="Delete" Text="Delete" />
                                </ItemTemplate>
                                <EditItemTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnMotilityUpdate" ValidationGroup="mEdit" CommandName="Update" Text="Update" />
                                    &nbsp;
                                            <asp:LinkButton runat="server" ID="lbtnMotilityCancel" CommandName="Cancel" Text="Cancel" />
                                </EditItemTemplate>
                                <FooterTemplate>
                                    <asp:LinkButton runat="server" ID="lbtnMotilityAdd" ValidationGroup="mAdd" CommandName="Add" Text="Add" />
                                </FooterTemplate>
                                <ItemStyle CssClass="rowCommandCol"></ItemStyle>
                                <HeaderStyle CssClass="rowCommandCol"></HeaderStyle>
                                <FooterStyle CssClass="rowCommandCol"></FooterStyle>
                            </telerik:GridTemplateColumn>
                        </Columns>
                    </MasterTableView>
                </telerik:RadGrid>
            </div>
            <div class="clearFloat"></div>
            <div class="cranialNerveWrapper examTabFloatLeft">
                <ucExamTab:ucMultiSelect runat="server" ID="ucCranialNerve" CssClass="cranialNerveWrapper" />
            </div>
            <div class="clearFloat"></div>
        </Contents>
    </ucExamTab:ucTestSummary>
</div>
