﻿using System;
using ViewModels.Exam;

namespace Controls.ExamTabv2
{
    /// <summary>
    /// The Exam Tab Relative Afferent Pupil Defect User Control
    /// </summary>
    public partial class ExamTabRelativeAfferentPupilDefectUserControl : BaseEventItem<RelativeAfferentPupilDefectEventModel>
    {
        #region Implemented Methods

        protected override void MapValidationGroup()
        {
            tbADPLaterality.ValidationGroup = ValidationGroup;
            regExValADPLaterality.ValidationGroup = ValidationGroup;
        }

        protected override void MapTestSummary()
        {
            ucTestSummary.ViewModel = EventViewModel;
            ucTestSummary.TestPerformExpandValues = RelativeAfferentPupilDefectEventModel.ShowTestDetailValues;
        }

        protected override void MapTestDetails()
        {
            lblVisitData.Text = EventViewModel.VisitData.DisplayText;
            ucVisitData.SelectedValue = EventViewModel.VisitData.IsYesSelected;

            lblADP.Text = EventViewModel.ADP.DisplayText;
            ucADP.Question = EventViewModel.ADP;

            lblADPLaterality.Text = EventViewModel.ADPLaterality.DisplayText;
            tbADPLaterality.Text = EventViewModel.ADPLaterality.ResponseText;
        }

        /// <summary>Forces the refresh.</summary>
        protected override void PerformForcedRefresh()
        {
            // Force Refresh on child controls
            ucTestSummary.PerformForcedRefresh();
        }

        /// <summary>Saves the item.</summary>
        /// <returns>Updated Relative Afferent Pupil Defect Event Model</returns>
        protected override RelativeAfferentPupilDefectEventModel SaveItem()
        {
            ucTestSummary.UpdateViewModel(EventViewModel);

            EventViewModel.VisitData.IsYesSelected = ucVisitData.SelectedValue;

            EventViewModel.ADP = ucADP.GetUpdatedQuestion();

            EventViewModel.ADPLaterality.ResponseText = tbADPLaterality.Text;

            return EventViewModel;
        }

        #endregion
    }
}