﻿using System;
using ViewModels.Exam;

namespace Controls.ExamTabv2
{
    /// <summary>
    /// The Exam Tab Static Threshold Perimetry User Control
    /// </summary>
    public partial class ExamTabStaticThresholdPerimetryUserControl : BaseEventItem<StaticThresholdPerimetryEventModel>
    {
        #region Implemented Methods

        protected override void MapValidationGroup()
        {
            tbMeanDeviation.ValidationGroup = ValidationGroup;
            regExValMeanDeviation.ValidationGroup = ValidationGroup;

            tbPatternStandardDeviation.ValidationGroup = ValidationGroup;
            regExValPatternStandardDeviation.ValidationGroup = ValidationGroup;

            tbFixationLoses.ValidationGroup = ValidationGroup;
            regExValFixationLoses.ValidationGroup = ValidationGroup;
        }

        protected override void MapTestSummary()
        {
            ucTestSummary.ViewModel = EventViewModel;
            ucTestSummary.TestPerformExpandValues = StaticThresholdPerimetryEventModel.ShowTestDetailValues;
        }

        protected override void MapTestDetails()
        {
            lblReferenceScale.Text = EventViewModel.ReferenceScale.DisplayText;
            ucReferenceScale.Question = EventViewModel.ReferenceScale;

            lblMeanDeviation.Text = EventViewModel.MeanDeviation.DisplayText;
            tbMeanDeviation.Text = EventViewModel.MeanDeviation.ResponseText;

            lblPatternStandardDeviation.Text = EventViewModel.PatternStandardDeviation.DisplayText;
            tbPatternStandardDeviation.Text = EventViewModel.PatternStandardDeviation.ResponseText;

            lblFixationLoses.Text = EventViewModel.FixationLoses.DisplayText;
            tbFixationLoses.Text = EventViewModel.FixationLoses.ResponseText;
        }

        /// <summary>Forces the refresh.</summary>
        protected override void PerformForcedRefresh()
        {
            // Force Refresh on child controls
            ucTestSummary.PerformForcedRefresh();
        }

        /// <summary>Saves the item.</summary>
        /// <returns>Updated Static Threshold Perimetry Event Model</returns>
        protected override StaticThresholdPerimetryEventModel SaveItem()
        {
            ucTestSummary.UpdateViewModel(EventViewModel);

            EventViewModel.ReferenceScale = ucReferenceScale.GetUpdatedQuestion();
            EventViewModel.MeanDeviation.ResponseText = tbMeanDeviation.TextWithLiterals;
            EventViewModel.PatternStandardDeviation.ResponseText = tbPatternStandardDeviation.TextWithLiterals;
            EventViewModel.FixationLoses.ResponseText = tbFixationLoses.TextWithLiterals;

            return EventViewModel;
        }

        #endregion
    }
}