﻿using System;
using System.Linq;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using ViewModels;
using ViewModels.Exam;

namespace Controls.ExamTabv2
{
    /// <summary>
    /// The Exam Tab Visual Acuity User Control
    /// </summary>
    public partial class ExamTabVisualAcuityUserControl : BaseEventItem<VisualAcuityEventModel>
    {
        #region Implement Methods

        protected override void MapValidationGroup()
        {
            tbUSPerformDistance.ValidationGroup = ValidationGroup;
            rangeValUSPerformDistance.ValidationGroup = ValidationGroup;

            tbJaegerPerformDistance.ValidationGroup = ValidationGroup;
            rangeValJaegerPerformDistance.ValidationGroup = ValidationGroup;

            tbDecimalAcuity.ValidationGroup = ValidationGroup;
            regExValDecimalAcuity.ValidationGroup = ValidationGroup;

            tbMUnitAcuity.ValidationGroup = ValidationGroup;
            regExValMUnitAcuity.ValidationGroup = ValidationGroup;
        }

        protected override void MapTestSummary()
        {
            ucTestSummary.ViewModel = EventViewModel;
            ucTestSummary.TestPerformExpandValues = VisualAcuityEventModel.ShowTestDetailValues;
        }

        protected override void MapTestDetails()
        {
            // Scale
            lblScale.Text = EventViewModel.Scale.DisplayText;
            ucScale.Question = EventViewModel.Scale;
            ucScale.ExtendDdlOnItemDataBound = ucScale_OnItemDataBound;

            // US Scale
            lblUSChartDistance.Text = EventViewModel.USChartDistance.DisplayText;
            ucUSChartDistance.SelectedValue = EventViewModel.USChartDistance.IsYesSelected;

            lblUSDifferentDistance.Text = EventViewModel.USDifferentDistance.DisplayText;
            ucUSDifferentDistance.SelectedValue = EventViewModel.USDifferentDistance.IsYesSelected;

            lblUSAcuity.Text = EventViewModel.USAcuity.DisplayText;
            tbUSPerformDistance.Text = EventViewModel.USPerformDistance.ResponseText;
            ucUSAcuity.Question = EventViewModel.USAcuity;

            lblUSAdjustment.Text = EventViewModel.USAdjustment.DisplayText;
            ucUSAdjustment.Question = EventViewModel.USAdjustment;

            lblUSUnits.Text = EventViewModel.USUnits.DisplayText;
            ucUSUnits.Question = EventViewModel.USUnits;

            // Metric Scale
            lblMetricChartDistance.Text = EventViewModel.MetricChartDistance.DisplayText;
            ucMetricChartDistance.SelectedValue = EventViewModel.MetricChartDistance.IsYesSelected;

            lblMetricDifferentDistance.Text = EventViewModel.MetricDifferentDistance.DisplayText;
            ucMetricDifferentDistance.SelectedValue = EventViewModel.MetricDifferentDistance.IsYesSelected;

            lblMetricAcuity.Text = EventViewModel.MetricAcuity.DisplayText;
            ucMetricPerformDistance.Question = EventViewModel.MetricPerformDistance;
            tbMetricAcuity.Text = EventViewModel.MetricAcuity.ResponseText;

            lblMetricAdjustment.Text = EventViewModel.MetricAdjustment.DisplayText;
            ucMetricAdjustment.Question = EventViewModel.MetricAdjustment;

            lblMetricUnits.Text = EventViewModel.MetricUnits.DisplayText;
            ucMetricUnits.Question = EventViewModel.MetricUnits;

            // Jaeger Scale
            lblJaegerPerformDistance.Text = EventViewModel.JaegerPerformDistance.DisplayText;
            tbJaegerPerformDistance.Text = EventViewModel.JaegerPerformDistance.ResponseText;

            lblJaegerAcuity.Text = EventViewModel.JaegerAcuity.DisplayText;
            ucJaegerAcuity.Question = EventViewModel.JaegerAcuity;

            lblJaegerAdjustment.Text = EventViewModel.JaegerAdjustment.DisplayText;
            ucJaegerAdjustment.Question = EventViewModel.JaegerAdjustment;

            lblJaegerUnits.Text = EventViewModel.JaegerUnits.DisplayText;
            ucJaegerUnits.Question = EventViewModel.JaegerUnits;

            // Decimal Scale
            lblDecimalAcuity.Text = EventViewModel.DecimalAcuity.DisplayText;
            tbDecimalAcuity.Text = EventViewModel.DecimalAcuity.ResponseText;

            lblDecimalAdjustment.Text = EventViewModel.DecimalAdjustment.DisplayText;
            ucDecimalAdjustment.Question = EventViewModel.DecimalAdjustment;

            lblDecimalUnits.Text = EventViewModel.DecimalUnits.DisplayText;
            ucDecimalUnits.Question = EventViewModel.DecimalUnits;

            // M Unit Scale
            lblMUnitAcuity.Text = EventViewModel.MUnitAcuity.DisplayText;
            tbMUnitAcuity.Text = EventViewModel.MUnitAcuity.ResponseText;

            lblMUnitAdjustment.Text = EventViewModel.MUnitAdjustment.DisplayText;
            ucMUnitAdjustment.Question = EventViewModel.MUnitAdjustment;

            lblMUnitUnits.Text = EventViewModel.MUnitUnits.DisplayText;
            ucMUnitUnits.Question = EventViewModel.MUnitUnits;

            // Non-Numeric Scale
            DataBindNonNumericAcuityGrid();

            // Qualifiers
            lblDistance.Text = EventViewModel.Distance.DisplayText;
            ucDistance.Question = EventViewModel.Distance;

            lblCorrection.Text = EventViewModel.Correction.DisplayText;
            ucCorrection.Question = EventViewModel.Correction;

            lblExamMethod.Text = EventViewModel.ExamMethod.DisplayText;
            ucExamMethod.Question = EventViewModel.ExamMethod;

            lblChartType.Text = EventViewModel.ChartType.DisplayText;
            ucChartType.Question = EventViewModel.ChartType;

            lblPrintSamples.Text = EventViewModel.PrintSample.DisplayText;
            ucPrintSamples.Question = EventViewModel.PrintSample;

            lblJaegerChartType.Text = EventViewModel.JaegerChartType.DisplayText;
            ucJaegerChartType.Question = EventViewModel.JaegerChartType;

            lblJaegerPrintSamples.Text = EventViewModel.JaegerPrintSamples.DisplayText;
            ucJaegerPrintSamples.Question = EventViewModel.JaegerPrintSamples;
        }

        /// <summary>Forces the refresh.</summary>
        protected override void PerformForcedRefresh()
        {
            // Force Refresh on child controls
            ucTestSummary.PerformForcedRefresh();
        }

        /// <summary>Saves the item.</summary>
        /// <returns>Updated Visual Acuity Event Model</returns>
        protected override VisualAcuityEventModel SaveItem()
        {
            ucTestSummary.UpdateViewModel(EventViewModel);

            // Scale
            EventViewModel.Scale = ucScale.GetUpdatedQuestion();

            // US Scale
            EventViewModel.USChartDistance.IsYesSelected = ucUSChartDistance.SelectedValue;
            EventViewModel.USDifferentDistance.IsYesSelected = ucUSDifferentDistance.SelectedValue;
            EventViewModel.USPerformDistance.ResponseText = tbUSPerformDistance.TextWithLiterals;
            EventViewModel.USAcuity = ucUSAcuity.GetUpdatedQuestion();
            EventViewModel.USAdjustment = ucUSAdjustment.GetUpdatedQuestion();
            EventViewModel.USUnits = ucUSUnits.GetUpdatedQuestion();

            // Metric Scale
            EventViewModel.MetricChartDistance.IsYesSelected = ucMetricChartDistance.SelectedValue;
            EventViewModel.MetricDifferentDistance.IsYesSelected = ucMetricDifferentDistance.SelectedValue;
            EventViewModel.MetricPerformDistance = ucMetricPerformDistance.GetUpdatedQuestion();
            EventViewModel.MetricAcuity.ResponseText = tbMetricAcuity.TextWithLiterals;
            EventViewModel.MetricAdjustment = ucMetricAdjustment.GetUpdatedQuestion();
            EventViewModel.MetricUnits = ucMetricUnits.GetUpdatedQuestion();

            // Jaeger Scale
            EventViewModel.JaegerPerformDistance.ResponseText = tbJaegerPerformDistance.TextWithLiterals;
            EventViewModel.JaegerAcuity = ucJaegerAcuity.GetUpdatedQuestion();
            EventViewModel.JaegerAdjustment = ucJaegerAdjustment.GetUpdatedQuestion();
            EventViewModel.JaegerUnits = ucJaegerUnits.GetUpdatedQuestion();

            // Decimal Scale
            EventViewModel.DecimalAcuity.ResponseText = tbDecimalAcuity.TextWithLiterals;
            EventViewModel.DecimalAdjustment = ucDecimalAdjustment.GetUpdatedQuestion();
            EventViewModel.DecimalUnits = ucDecimalUnits.GetUpdatedQuestion();

            // M Unit Scale
            EventViewModel.MUnitAcuity.ResponseText = tbMUnitAcuity.TextWithLiterals;
            EventViewModel.MUnitAdjustment = ucMUnitAdjustment.GetUpdatedQuestion();
            EventViewModel.MUnitUnits = ucMUnitUnits.GetUpdatedQuestion();

            // Non-Numeric Scale - Handled by the grid

            // Qualifiers
            EventViewModel.Distance = ucDistance.GetUpdatedQuestion();
            EventViewModel.Correction = ucCorrection.GetUpdatedQuestion();
            EventViewModel.ExamMethod = ucExamMethod.GetUpdatedQuestion();
            EventViewModel.ChartType = ucChartType.GetUpdatedQuestion();
            EventViewModel.PrintSample = ucPrintSamples.GetUpdatedQuestion();
            EventViewModel.JaegerChartType = ucJaegerChartType.GetUpdatedQuestion();
            EventViewModel.JaegerPrintSamples = ucJaegerPrintSamples.GetUpdatedQuestion();

            return EventViewModel;
        }

        #endregion

        #region Events

        protected void ucScale_OnItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            Choice choice = (Choice) e.Item.DataItem;

            e.Item.Attributes["ExpandUSScale"] =
                (choice.Code == VisualAcuityEventModel.ChoiceCodes.Scale.USScale).ToString().ToLower();
            
            e.Item.Attributes["ExpandMetricScale"] =
                (choice.Code == VisualAcuityEventModel.ChoiceCodes.Scale.MetricScale).ToString().ToLower();
            
            e.Item.Attributes["ExpandJaegerScale"] =
                (choice.Code == VisualAcuityEventModel.ChoiceCodes.Scale.JaegerScale).ToString().ToLower();
            
            e.Item.Attributes["ExpandDecimalScale"] =
                (choice.Code == VisualAcuityEventModel.ChoiceCodes.Scale.DecimalScale).ToString().ToLower();
            
            e.Item.Attributes["ExpandMUnitScale"] =
                (choice.Code == VisualAcuityEventModel.ChoiceCodes.Scale.MUnitScale).ToString().ToLower();
            
            e.Item.Attributes["ExpandNonNumericScale"] =
                (choice.Code == VisualAcuityEventModel.ChoiceCodes.Scale.NonNumericScale).ToString().ToLower();
        }

        protected void gvNonNumericAcuity_OnItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.EditItem)
            {
                var dataItem = e.Item.DataItem as Choice;

                if (dataItem != null &&
                    VisualAcuityEventModel.EnableNonNumericAcuityValidation.Any(v => v == dataItem.Code))
                {
                    var reqValidator = (RequiredFieldValidator) e.Item.FindControl("reqValNonNumericComment");
                    reqValidator.Enabled = true;

                    var compValidator = (CompareValidator) e.Item.FindControl("compValNonNumericComment");
                    compValidator.Enabled = true;
                }
            }

            if (e.Item.ItemType == GridItemType.Footer)
            {
                RadComboBox visitDataComboBox = (RadComboBox) e.Item.FindControl("ddlNonNumericAcuity");
                MapSelectField(visitDataComboBox, EventViewModel.NonNumericAcuity);
            }
        }

        protected void gvNonNumericAcuity_OnItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "Edit")
            {
                gvNonNumericAcuity.EditIndexes.Add(e.Item.ItemIndex);
                gvNonNumericAcuity.MasterTableView.ShowFooter = false;
            }

            if (e.CommandName == "Delete")
            {
                var selectedChoice = e.Item.DataItem as Choice;

                if (selectedChoice != null)
                {
                    EventViewModel.NonNumericAcuity.SelectedChoices.RemoveAll(c => c.Code == selectedChoice.Code);
                }
            }

            if (e.CommandName == "Cancel")
            {
                gvNonNumericAcuity.EditIndexes.Clear();
                gvNonNumericAcuity.MasterTableView.ShowFooter = true;
            }

            if (e.CommandName == "Update")
            {
                var dataView = e.Item.DataItem as Choice;
                Choice selectedChoice =
                    dataView != null
                        ? EventViewModel.NonNumericAcuity.SelectedChoices.FirstOrDefault(c => c.Code == dataView.Code)
                        : null;

                if (selectedChoice != null)
                {
                    EventViewModel.NonNumericAcuity.SelectedChoices.Remove(selectedChoice);

                    TextBox tbNonNumericScaleComment = (TextBox) e.Item.FindControl("tbNonNumericAcuityComment");
                    selectedChoice.Comment = tbNonNumericScaleComment.Text;

                    EventViewModel.NonNumericAcuity.SelectedChoices.Add(selectedChoice);
                }

                gvNonNumericAcuity.MasterTableView.ShowFooter = true;
            }

            if (e.CommandName == "Add")
            {
                RadComboBox comboBox = (RadComboBox) e.Item.FindControl("ddlNonNumericAcuity");
                string selectedChoiceCode = comboBox.SelectedValue;
                Choice selectedChoice =
                    EventViewModel.NonNumericAcuity.AllChoices.FirstOrDefault(c => c.Code == selectedChoiceCode);

                if (selectedChoice != null)
                {
                    TextBox tbNonNumericScaleComment = (TextBox) e.Item.FindControl("tbNonNumericAcuityComment");
                    selectedChoice.Comment = tbNonNumericScaleComment.Text;

                    EventViewModel.NonNumericAcuity.SelectedChoices.Add(selectedChoice);

                    comboBox.Text = string.Empty;
                    tbNonNumericScaleComment.Text = string.Empty;
                }
            }

            DataBindNonNumericAcuityGrid();
        }

        protected void ddlNonNumericAcuity_OnItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            Choice choice = (Choice) e.Item.DataItem;
            e.Item.Attributes["RequiresComment"] = choice.RequiresComment.ToString().ToLower();
            e.Item.Attributes["EnableNonNumericAcuityValidation"] =
                VisualAcuityEventModel.EnableNonNumericAcuityValidation.Any(v => v == choice.Code).ToString().ToLower();
        }

        #endregion

        private void DataBindNonNumericAcuityGrid()
        {
            gvNonNumericAcuity.DataSource = EventViewModel.NonNumericAcuity.SelectedChoicesOrderd;
            gvNonNumericAcuity.DataBind();
        }
    }
}