﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ReviewerCommentControl.ascx.cs" Inherits="controls_ReviewComment_ReviewerCommentControl" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<telerik:RadCodeBlock runat="server" ID="rcbScrollScript">
        <script type="text/javascript">
            $(document).ready(function() {{ 
                // Scroll to area selected for reviewing comments .. 
                if ('<%=IsSelectedFromReviewGrid%>' == 'True') {
                    if ('<%=IsCommentEditable%>' == 'True') {
                        var element = $('#<%=TextBoxReviewComment.ClientID%>');
                        var pos = element.offset();
                        var top = pos.top - 20;
                        var left = pos.left - 20;
                        window.scrollTo((left < 0 ? 0 : left), (top < 0 ? 0 : top));
                        element.focus();
                    }
                    else {
                        var element = $('#<%=LabelReviewCommentReadOnly.ClientID%>');
                        var pos = element.offset();
                        var top = pos.top - 20;
                        var left = pos.left - 20;
                        window.scrollTo((left < 0 ? 0 : left), (top < 0 ? 0 : top));
                        element.focus();
                    }
                }
            }}); 
        </script>
    </telerik:RadCodeBlock>

<asp:Panel ID="PanelReviewComment" runat="server" Visible="true" CssClass="reviewCommentControl">
    <asp:Panel ID="PanelReviewCommentsButtons" CssClass="reviewCommentButtonContainer" runat="server" Visible="true">
        <asp:ImageButton ID="ImageButtonCommentAdd" 
            runat="server"
            CssClass="reviewCommentButtonAdd"
            AlternateText="Add comment"
            ImageUrl="~/images/button_CommentAdd-40-TG.jpg"
            ToolTip="Add Comment"
            OnClientClick="return MEVIR.Encounter.ReviewComment.AddButtonClick(this);"
            />
        <asp:ImageButton ID="ImageButtonCommentOpen" 
            runat="server"
            CssClass="reviewCommentButtonOpen"
            AlternateText="Open comment"
            ImageUrl="~/images/button_CommentAlert-40-TG.jpg"
            ToolTip="Open Comment"
            OnClientClick="return MEVIR.Encounter.ReviewComment.OpenButtonClick(this)"
            />
        <asp:ImageButton ID="ImageButtonCommentClose"
            runat="server"
            CssClass="reviewCommentButtonClose"
            AlternateText="Close comment"
            ImageUrl="~/images/button_CommentClose-40-TG.jpg"
            ToolTip="Close Comment"
            OnClientClick="return MEVIR.Encounter.ReviewComment.CloseButtonClick(this);"
            />
        
        <asp:ImageButton ID="ImageButtonCommentReturnToList"
            runat="server"
            CssClass="reviewCommentButtonReturnToList"
            AlternateText="Save and return to comment list"
            ToolTip="Save and return to comment list"
            ImageUrl="~/images/button_CommentReturn-40-TG.jpg"
            onclick="ImageButtonCommentReturnToList_Click" />

    </asp:Panel>  
    <asp:Panel ID="PanelReviewCommentsContent" CssClass="reviewCommentContent"
       runat="server" Visible="true">
        <asp:Panel ID="PanelReviewCommentsGrouping" CssClass="reviewCommentsPanel" BackColor="#E6E6E6"
            GroupingText="Review Comments &nbsp;&nbsp;" runat="server" Visible="true" Width="100%">
            <asp:TextBox ID="TextBoxReviewComment" 
                CssClass="reviewCommentTextBox"
                ToolTip="Enter Review Comments" 
                runat="server" 
                Width="99%" 
                TextMode="MultiLine" 
                Rows="3" >
            </asp:TextBox>
            <asp:RegularExpressionValidator ID="RegularExpressionValidatorTextBoxReviewComment" runat="server" 
                ErrorMessage="Review Comment needs to be less than 1000 characters."
                ControlToValidate="TextBoxReviewComment"
                ValidationExpression="^[\s\S]{0,1000}$"
                />
            <asp:Label ID="LabelReviewCommentReadOnly" Font-Italic="true"
                runat="server" 
                Text=""
                SkinID="DataLabel">
            </asp:Label>
            <br />
            <asp:CheckBox ID="CheckBoxResolved" runat="server" Text="Resolved" Font-Italic="true" ToolTip="Click to Resolve" />
            &nbsp;&nbsp;&nbsp;
            <asp:CheckBox ID="CheckBoxApproved" runat="server" Text="Approved" Font-Italic="true" ToolTip="Click to Approve" />
        </asp:Panel>
    <br />
    </asp:Panel>      
</asp:Panel>
<asp:HiddenField ID="hfReviewCommentId" runat="server" Value=""/>     
<asp:HiddenField ID="hfReviewCommentType" runat="server" Value="" />