﻿// Copy values from TextBox, DropDownList, or RadioButtonList
// to HiddenField so that we can set enableviewstate=false for all controls.
function SetBaseControlTextValue(baseControl, hiddenFieldID) {
    var hiddenFieldControl = document.getElementById(hiddenFieldID);
    if (hiddenFieldControl != null) {
        hiddenFieldControl.value = baseControl.value;
    }
}

// Copy values from CheckBox
// to HiddenField so that we can set enableviewstate=false for all controls.
function SetBaseControlCheckBoxTextValue(baseControl, hiddenFieldID) {
    var hiddenFieldControl = document.getElementById(hiddenFieldID);
    if (hiddenFieldControl != null) {
        if (baseControl.checked == true) {
            hiddenFieldControl.value = "true";
        }
        else {
            hiddenFieldControl.value = "false";
        }
    }
}

// Custom Validator function for date validation
function ValidateDate(sender, args) {
    args.IsValid = true;
    var textBoxId;
    var txtDate;
    
    // get the client id for text box control from sender.outerHTML
    textBoxId = sender.outerHTML;
    textBoxId = textBoxId.substring(textBoxId.indexOf("controltovalidate") + 19);
    textBoxId = textBoxId.substring(0, textBoxId.indexOf("\""));
    txtDate = document.getElementById(textBoxId);
    
    if (txtDate == null) {
        txtDate = document.getElementById("ctl00_ContentPlaceHolder_EncounterTabUserControl_TextBoxDate");
    }
    
    if (txtDate != null) {
        txtDate = txtDate.value;

        if (isValidDate(txtDate)) {
            args.IsValid = true;
        }
        else {
            args.IsValid = false;
        }
    }
}

function isValidDate(txtDate) {
    var objDate,        // date object initialized from the txtDate string         
    mSeconds,           // txtDate in milliseconds         
    day,                // day         
    month,              // month         
    year,               // year
    currentSeconds;     // current date time in milliseconds

    // date length should be 10 characters (no more no less)     
    if (txtDate.length !== 10) {
        return false;
    }

    // third and sixth character should be '/'     
    if (txtDate.substring(2, 3) !== '/' || txtDate.substring(5, 6) !== '/') {
        return false;
    }

    // extract month, day and year from the txtDate (expected format is mm/dd/yyyy)     
    // subtraction will cast variables to integer implicitly (needed     
    // for !== comparing)     
    month = txtDate.substring(0, 2) - 1;
    // because months in JS start from 0    

    day = txtDate.substring(3, 5) - 0;
    year = txtDate.substring(6, 10) - 0;

    // test year range     
    if (year < 1900) {
        return false;
    }

    // convert txtDate to milliseconds     
    mSeconds = (new Date(year, month, day)).getTime();
    // initialize Date() object from calculated milliseconds     
    objDate = new Date();
    objDate.setTime(mSeconds);
    // compare input date and parts from Date() object     
    // if difference exists then date isn't valid     
    if (objDate.getFullYear() !== year
            || objDate.getMonth() !== month
            || objDate.getDate() !== day) {
        return false;
    }

    // current date time in milliseconds
    currentSeconds = (new Date()).getTime();
    if (mSeconds > currentSeconds) {
        return false;
    }

    // otherwise return true     
    return true;
}

//Horizontal menu has the title on the TD object
function UpdateHorizontalMenu(menuId) {
    var menu = document.getElementById(menuId);
    if (menu != null) {
        var links = menu.getElementsByTagName("a");
        if (links != null) {
            for (var i = 0; i < links.length; i++) {
                //                      td1        tr1        tb1         ta1         td2
                var objTitle = links[i].parentNode.parentNode.parentNode.parentNode.parentNode
                if (objTitle != null) {
                    links[i].title = objTitle.title;
                }
            }
        }
    }
}

//Vertical menu has the title on the TR object
function UpdateVerticalMenu(menuId) {
    var menu = document.getElementById(menuId);
    if (menu != null) {
        var links = menu.getElementsByTagName("a");
        if (links != null) {
            for (var i = 0; i < links.length; i++) {
                //                      td1        tr1        tb1         ta1         td2       tr2
                var objTitle = links[i].parentNode.parentNode.parentNode.parentNode.parentNode.parentNode
                if (objTitle != null) {
                    links[i].title = objTitle.title;
                }
            }
        }
    }
}

//Add titles to header sort hyperlinks and footer pager hyperlinks
function UpdateGridView(gridViewID) {
    var gridView = document.getElementById(gridViewID);
    if (gridView != null) {
        for (var i = 0; i < gridView.rows.length; i++) {
            var cells = gridView.rows[i].cells;
            if (cells != null) {
                if (i == 0) {
                    for (var j = 0; j < cells.length; j++) {
                        var links = cells[j].getElementsByTagName("a");
                        if (links != null) {
                            for (var k = 0; k < links.length; k++) {
                                links[k].title = "Column header, select to sort by " + links[k].innerHTML;
                            }
                        }
                    }
                }
                else if (i == (gridView.rows.length - 1)) {
                    var blnNumbers = false;
                    for (var j = 0; j < cells.length; j++) {
                        var links = cells[j].getElementsByTagName("a");
                        if (links != null) {
                            for (var k = 0; k < links.length; k++) {
                                if (links[k].innerHTML == "First Page") {
                                    links[k].title = "Select to go to the First Page";
                                }
                                else if (links[k].innerHTML == "Last Page") {
                                    links[k].title = "Select to go to the Last Page";
                                }
                                else if (links[k].innerHTML == "...") {
                                    if (blnNumbers) {
                                        links[k].title = "Select to go to the next group of pages";
                                    }
                                    else {
                                        links[k].title = "Select to go to the previous group of pages";
                                    }
                                }
                                else {
                                    blnNumbers = true;
                                    links[k].title = "Select to go to page " + links[k].innerHTML;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}