﻿/* Exam Tab Motility Javascript */

var MEVIR = MEVIR || {};
MEVIR.Exam = MEVIR.Exam || {};
MEVIR.Exam.Motility = {
    ShowHideMotilityComment: function ($ddlComboBox) {
        var $ddlChoices = $('#' + $ddlComboBox.get_id());
        var $containerDiv = $ddlChoices.closest('tr');
        var $tbComment = $containerDiv.find('#motilityCommentWrapper');
        var $regExValMotility = $containerDiv.find('[id $=regExValMotility]');

        var selectedItem = $ddlComboBox.get_selectedItem();

        var showComment = false;
        var enableRegExValMotility = false;

        if (selectedItem != null) {
            var selectedAttributes = selectedItem.get_attributes();

            var requiresCmt = selectedAttributes.getAttribute("RequiresComment");
            var regExValMotilityCtlEnabled = selectedAttributes.getAttribute("RegExValMotilityEnabled");

            showComment = requiresCmt === "true";
            enableRegExValMotility = regExValMotilityCtlEnabled === "true";
        }

        ValidatorEnable($regExValMotility[0], enableRegExValMotility);
        MEVIR.Exam.Common.ShowHideItem($tbComment, showComment);

    },

    ToggleNystagmusOptions: function($ddlComboBox) {
        var $nystagmusOptions = $('#nystagmusOptionsWrapper');

        var selectedItem = $ddlComboBox.get_selectedItem();

        var showOptions = false;

        if (selectedItem != null) {
            var selectedAttributes = selectedItem.get_attributes();
            
            var expandNystagmus = selectedAttributes.getAttribute("ExpandNystagmus");

            showOptions = expandNystagmus === "true";
        }

        MEVIR.Exam.Common.ShowHideItem($nystagmusOptions, showOptions);
    },

    MotilityOnLoad: function (sender) {
        MEVIR.Exam.Motility.ShowHideMotilityComment(sender);
    },

    MotilitySelectionChanged: function (sender) {
        MEVIR.Exam.Motility.ShowHideMotilityComment(sender);
    },

    NystagmusOnLoad: function(sender) {
        MEVIR.Exam.Motility.ToggleNystagmusOptions(sender);
        MEVIR.Exam.Common.SingleSelectOnLoad(sender);
    },

    NystagmusSelectionChanged: function (sender) {
        MEVIR.Exam.Motility.ToggleNystagmusOptions(sender);
        MEVIR.Exam.Common.SingleSelectSelectionChanged(sender);
    }
};
