﻿/* Exam Tab Anterior Chamber Javascript */

var MEVIR = MEVIR || {};
MEVIR.Exam = MEVIR.Exam || {};
MEVIR.Exam.VisualAcuity = {
    ToggleScale: function ($ddlComboBox) {
        var $eventWrapper = $('#visualAcuityEvent');
        var $pnlUSScale = $eventWrapper.find('[id $=pnlUSScale]');
        var $pnlMetricScale = $eventWrapper.find('[id $=pnlMetricScale]');
        var $pnlJaegerScale = $eventWrapper.find('[id $=pnlJaegerScale]');
        var $pnlDecimalScale = $eventWrapper.find('[id $=pnlDecimalScale]');
        var $pnlMUnitScale = $eventWrapper.find('[id $=pnlMUnitScale]');
        var $pnlNonNumericScale = $eventWrapper.find('[id $=pnlNonNumericScale]');
        var $pnlQualifiers = $eventWrapper.find('[id $=pnlQualifiers]');
        var $pnlStandardChartPrint = $eventWrapper.find('[id $=pnlStandardChartPrint]');
        var $pnlJaegerChartPrint = $eventWrapper.find('[id $=pnlJaegerChartPrint]');

        var $rangeValUSPerformDistance = $eventWrapper.find('[id $=rangeValUSPerformDistance]');
        var $rangeValJaegerPerformDistance = $eventWrapper.find('[id $=rangeValJaegerPerformDistance]');
        var $regExValDecimalAcuity = $eventWrapper.find('[id $=regExValDecimalAcuity]');
        var $regExValMUnitAcuity = $eventWrapper.find('[id $=regExValMUnitAcuity]');

        var selectedItem = $ddlComboBox.get_selectedItem();

        var expandUSScale = false;
        var expandMetricScale = false;
        var expandJaegerScale = false;
        var expandDecimalScale = false;
        var expandMUnitScale = false;
        var expandNonNumericScale = false;
        var expandQualifiers = false;
        var expandStandardChartPrint = false;
        var expandJaegerChartPrint = false;


        if (selectedItem != null) {
            var selectedAttributes = selectedItem.get_attributes();

            expandUSScale = selectedAttributes.getAttribute("ExpandUSScale") === "true";
            expandMetricScale = selectedAttributes.getAttribute("ExpandMetricScale") === "true";
            expandJaegerScale = selectedAttributes.getAttribute("ExpandJaegerScale") === "true";
            expandDecimalScale = selectedAttributes.getAttribute("ExpandDecimalScale") === "true";
            expandMUnitScale = selectedAttributes.getAttribute("ExpandMUnitScale") === "true";
            expandNonNumericScale = selectedAttributes.getAttribute("ExpandNonNumericScale") === "true";
            expandQualifiers = true;
            expandStandardChartPrint = !expandJaegerScale;
            expandJaegerChartPrint = expandJaegerScale;
        }

        MEVIR.Exam.Common.ShowHideItem($pnlUSScale, expandUSScale);
        MEVIR.Exam.Common.ShowHideItem($pnlMetricScale, expandMetricScale);
        MEVIR.Exam.Common.ShowHideItem($pnlJaegerScale, expandJaegerScale);
        MEVIR.Exam.Common.ShowHideItem($pnlDecimalScale, expandDecimalScale);
        MEVIR.Exam.Common.ShowHideItem($pnlMUnitScale, expandMUnitScale);
        MEVIR.Exam.Common.ShowHideItem($pnlNonNumericScale, expandNonNumericScale);
        MEVIR.Exam.Common.ShowHideItem($pnlQualifiers, expandQualifiers);
        MEVIR.Exam.Common.ShowHideItem($pnlStandardChartPrint, expandStandardChartPrint);
        MEVIR.Exam.Common.ShowHideItem($pnlJaegerChartPrint, expandJaegerChartPrint);

        ValidatorEnable($rangeValUSPerformDistance[0], expandUSScale);
        ValidatorEnable($rangeValJaegerPerformDistance[0], expandJaegerScale);
        ValidatorEnable($regExValDecimalAcuity[0], expandDecimalScale);
        ValidatorEnable($regExValMUnitAcuity[0], expandMUnitScale);
    },

    ShowHideNonNumericAcuityComment: function ($ddlComboBox) {
        var $ddlChoices = $('#' + $ddlComboBox.get_id());
        var $containerDiv = $ddlChoices.closest('tr');
        var $tbComment = $containerDiv.find('#nonNumericAcuityCommentWrapper');
        var $reqValCtrl = $containerDiv.find('[id $=reqValNonNumericComment]');
        var $compValCtrl = $containerDiv.find('[id $=compValNonNumericComment]');

        var selectedItem = $ddlComboBox.get_selectedItem();

        var showComment = false;
        var enableValidators = false;

        if (selectedItem != null) {
            var selectedAttributes = selectedItem.get_attributes();

            var requiresCmt = selectedAttributes.getAttribute("RequiresComment");
            var enableNonNumericAcuityValidation = selectedAttributes.getAttribute("EnableNonNumericAcuityValidation");

            showComment = requiresCmt === "true";
            enableValidators = enableNonNumericAcuityValidation === "true";
        }

        ValidatorEnable($reqValCtrl[0], enableValidators);
        ValidatorEnable($compValCtrl[0], enableValidators);
        MEVIR.Exam.Common.ShowHideItem($tbComment, showComment);
    },

    TestPerformedSelection: function ($comboBoxTestPerform) {
        var $eventWrapper = $('#visualAcuityEvent');
        var $rangeValUSPerformDistance = $eventWrapper.find('[id $=rangeValUSPerformDistance]');
        var $rangeValJaegerPerformDistance = $eventWrapper.find('[id $=rangeValJaegerPerformDistance]');
        var $regExValDecimalAcuity = $eventWrapper.find('[id $=regExValDecimalAcuity]');
        var $regExValMUnitAcuity = $eventWrapper.find('[id $=regExValMUnitAcuity]');

        var enableValidator = false;
        var selectedItem = $comboBoxTestPerform.get_selectedItem();

        if (selectedItem != null) {
            var selectedAttributes = selectedItem.get_attributes();
            var showTestDetailsValue = selectedAttributes.getAttribute("TestPerformExpand");

            enableValidator = showTestDetailsValue === "true";
        }

        // Toggle Validator when hiding
        if (enableValidator) {
            var $ucScaleCtrl = $('[id *=ucScale][id $=ddlSingleSelect]');
            var $ucScale = $find($ucScaleCtrl.attr('id'));

            if ($ucScale != null) {
                MEVIR.Exam.VisualAcuity.ToggleScale($ucScale);
            }
        } else {
            ValidatorEnable($rangeValUSPerformDistance[0], false);
            ValidatorEnable($rangeValJaegerPerformDistance[0], false);
            ValidatorEnable($regExValDecimalAcuity[0], false);
            ValidatorEnable($regExValMUnitAcuity[0], false);
        }
    },

    ScaleOnLoad: function (sender) {
        MEVIR.Exam.VisualAcuity.ToggleScale(sender);
        MEVIR.Exam.Common.SingleSelectOnLoad(sender);
    },

    ScaleSelectionChanged: function (sender) {
        MEVIR.Exam.VisualAcuity.ToggleScale(sender);
        MEVIR.Exam.Common.SingleSelectSelectionChanged(sender);
    },

    NonNumericAcuityOnLoad: function (sender) {
        MEVIR.Exam.VisualAcuity.ShowHideNonNumericAcuityComment(sender);
    },

    NonNumericAcuitySelectionChanged: function (sender) {
        MEVIR.Exam.VisualAcuity.ShowHideNonNumericAcuityComment(sender);
    },

    TestPerformedSelectionChanged: function (sender) {
        MEVIR.Exam.VisualAcuity.TestPerformedSelection(sender);
        MEVIR.Exam.Summary.TestPerformedSelection(sender);
    },

    TestPerformedOnLoad: function (sender) {
        MEVIR.Exam.VisualAcuity.TestPerformedSelection(sender);
        MEVIR.Exam.Summary.TestPerformedSelection(sender);
    }
};
